﻿(function () {
	console.debug("◆linda.js loaded.");

	if ($.type(window.linda) == "undefined") {
		window.linda = {};
	}

})();

(function (linda) {
	linda.user = {};

	linda.user.userID = null;
	linda.user.fullName = null;

	linda.user.linda_viewDefaultFilterMine = false;
	linda.user.linda_accountDepartmentID = null;

	linda.user.parentCustomerId = null;
	linda.user.linda_userid = null;
	linda.user.linda_jobclasscd = null;

})(window.linda);

(function (linda) {
	linda.settings = {};

	/** C1見積編集画面URL */
	linda.settings.c1QuoteEditUrl = "https://cas-cone-dev.it-ex.com/c1/xhtml/scr/c1is/C1IS01001D.xhtml?gid=C1QU01011D&";

	/** トークン取得URL */
	linda.settings.getTokenUrl = "https://cas-partner-dev.it-ex.com/_services/auth/token";

	/** 見積公開API */
	linda.settings.quotePublishingApi = "https://protected502.devsbcs.com/QuotePublishingApi";

	/** 特価申請キャンセルURL */
	linda.settings.specialApplicationCancelUrl = "https://cas-cone-stg.it-ex.com/c1/xhtml/scr/c1is/C1IS01001D.xhtml?";
	
	/** 外向けAPIのURL */
	linda.settings.outSideApiUrl = "https://protected502.devsbcs.com/"
	
	/** 注文入力画面URL */
	linda.settings.createOrderUrl = "https://cas-partner-dev.it-ex.com/salesorderview/create-order/?";

	/** C1帳票(見積書・注文書)出力画面URL */
	linda.settings.c1QuoteOrderReportUrl = "https://cas-cone-stg.it-ex.com/c1/xhtml/scr/c1is/C1IS01001D.xhtml?gid=C1QU01032D&";

	/** 申請書ステータスヘルプURL */
	linda.settings.applicationStatusHelpUrl = "https://cas-portal-dev.it-ex.com/contents/page/authority#request";
	
	/** C1商品詳細画面URL */
	linda.settings.c1ProductDetailUrl = "https://cas-cone-stg.it-ex.com/c1/xhtml/scr/c1is/C1IS01001D.xhtml?gid=C1IS02021D&hnc=";

	/** 税抜免責文言 */
	linda.settings.taxImmunityMessage = "※特に記載がない限り、表示価格には消費税は含まれません。";

	/** パートナーフロントURL **/
	linda.settings.partnerFrontUrl = "https://cas-portal-dev.it-ex.com";

})(window.linda);

(function (linda) {
	linda.enums = {};


	/**
	 * 販社ステータスオプションセット
	 */
	linda.enums.dealerStatusOptions = {
		DEALERCHECK: "100000000"						// 貴社確認中
		, CSCHECK: "100000001"							// C&S対応中
		, EXPIRED: "100000002"							// 有効期限切れ
		, ORDERED: "100000003"							// 注文済
		, CANCEL: "100000004"							// 注文キャンセル済
	};

	/**
	 * サポート案件ステータスオプションセット
	 */
	linda.enums.incidentStatusOptions = {
		RECEIVED: "100000000"							// 受付済
		, DEALERCHECK: "100000001"						// 貴社確認中
		, CSCHECK: "100000002"							// C&S対応中
		, QUOTED: "100000003"							// 見積済
		, CLOSED: "100000004"							// クローズ
		, ORDERED: "100000005"							// 注文済
		, CANCEL: "100000006"							// 注文キャンセル済
		, TEMPORARILY: "100000007"                      // 一時保存
	};

	/**
	 * コンタクト履歴/ファイル共有カテゴリオプションセット
	 */
	linda.enums.contactsHistoryCategoryOptions = {
		CASEQUOTE_STATUSCHECK: "100000000"				// 見積依頼詳細画面-状況確認/追加情報回答
		, CASEQUOTE_QUOTECONTACT: "100000001"			// 見積依頼詳細画面-見積内容問い合わせ
		, CASEQUOTE_REQUOTE: "100000002"				// 見積依頼詳細画面-再見積依頼
		, QUOTE_STATUSCHECK: "100000100"				// 見積詳細画面-状況確認/追加情報回答
		, QUOTE_QUOTECONTACT: "100000101"				// 見積詳細画面-見積内容問い合わせ
		, QUOTE_REQUOTE: "100000102"					// 見積詳細画面-再見積依頼
		, SALESORDER_STATUSCHECK: "100000200"			// 注文詳細画面-状況確認/追加情報回答
		, SALESORDER_ORDERCHANGE: "100000201"			// 注文詳細画面-注文内容変更依頼
		, CASE_STATUSCHECK: "100000300"					// 問い合わせ詳細画面-状況確認/追加情報回答
	};


	/**
	 * コンタクト履歴作成ダイアログのタイプ
	 */
	linda.enums.contactsHistoryDialogTypes = {
		CASE: "1"										// 問い合わせ
		, CASEQUOTE: "2"								// 見積依頼
		, QUOTE: "3"									// 見積
		, SALESORDER: "4"								// 発注
	};

	/**
	 * 受注ステータスオプションセット
	 */
	linda.enums.salesOrderStatusOptions = {
		CANCELED: "100005103"							// キャンセル済
		, APPROVAL_PENDING: "100005100"					// 貴社内承認待ち
		, SBCS_PENDING: "100005101"						// SB C&S 承認待ち
		, ACCEPTED: "100005102"							// 受付済
		, APPROVED: "100005104"							// 注文承認済
		, REJECTION: "100005105"						// 注文却済
		, PAYMENT_WAIT: "100005106"						// 入金待ち
	};

	/**
	 * 注文申請書ステータスオプションセット
	 */
	linda.enums.salesOrderApplicationFormStatusOptions = {
		UNNECESSARY: "100000000"						// 不要
		, NOTSUBMITTED_ALL: "100000001"					// 全て未提出
		, NOTSUBMITTED_PART: "100000002"				// 一部未提出
		, SUBMITTED: "100000003"						// 提出済
		, SEPARATE_GUIDE: "100000004"					// 別途案内
		, SEPARATE_GUIDE_NECESSARY: "100000005"			// 必要に応じて別途案内
		, UNDETERMINED: "100000999"			            // 未判定
	};

	/**
	 * 出荷ステータスオプションセット
	 */
	linda.enums.ShippingStatusOptions = {
		NOTSHIPPED: "100000002"						// 未出荷
		, PARTIALLYSHIPPED: "100000001"					// 一部出荷済
		, SHIPPED: "100000000"				// 出荷済
		, CANCELED: "100000003"						// キャンセル済
	};

	/**
	 * サポート案件の見積依頼先部門
	 */
	linda.enums.quoteOrderTargetDept = {
		RESPONSIBLE_SALES: "100000000"					// 貴社営業担当
		, MS_LICENSE_RESPONSIBLE: "100000001"			// MSライセンス包括契約案件担当(セレクト/EA/ESA/SPLA/MPSA等)
	};

	/**
	 * 注文ファイルアップロードステータス
	 */
	linda.enums.salesOrderFileUploadStatus = {
		ERROR: "100000002"					            // エラー
		, ALERT: "100000003"			                // アラート
		, COMPLETE: "100000005"			                // 注文完了
	};

	/**
	 * C1ステータス
	 */
	linda.enums.c1QuoteStatus = {
		CREATING: "01"					                // 作成中
		, CREATED: "02"			                        // 作成済
		, ORDER_ISSUED: "07"			                // 注文書発行済
		, ORDERED: "09"			                        // 注文済
		, SPECIAL_PRICE_REQUESTING: "10"			    // 特価依頼中
		, SPECIAL_PRICE_CONFIRM: "11"			        // 特価確定
		, SPECIAL_PRICE_REQUEST_HISTORY: "12"			// 特価依頼履歴
		, SPECIAL_PRICE_NO_REQUEST: "13"			    // 特価依頼不可
	};

	linda.enums.jobClassCd = {
	    INTERNAL_USER: "90"                             // 社内ユーザー
	};

})(window.linda);

(function (linda) {
	linda.util = {};

	/**
	 * 値がundefinedか
	 * @param {*} in_value 対象の変数
	 * @param {string} [in_descendants] 対象の子孫要素のパス
	 * @return {boolean} 引数がundefinedの場合、true
	 */
	linda.util.isUndef = function (in_value, in_descendants) {
		if ($.type(in_value) == "undefined") {
			return true;
		}

		if (this.isUndef(in_descendants) || this.isNullOrEmpty(in_descendants)) {
			return false;
		}

		if (in_descendants.substr(0, 1) != ".") {
			in_descendants = "." + in_descendants;
		}

		let obj = in_value;
		let descendants = in_descendants.split(".");

		for (let idx = 1; idx < descendants.length; idx++) {
			obj = obj[descendants[idx]];

			let ret = this.isUndef(obj);
			if (ret) {
				return true;
			}
		}

		return false;
	};

	/**
	 * 値がundefinedまたはnullか
	 * @param {*} in_value 対象の変数
	 * @return {boolean} 引数がundefinedまたはnullの場合、true
	 */
	linda.util.isUndefOrNull = function (in_value) {
		return (this.isUndef(in_value) || in_value === null);
	};

	/**
	 * 値がnullまたは空文字列か
	 * @param {*} in_value 対象の変数
	 * @return {boolean} 引数がnullまたは空文字列の場合、true
	 */
	linda.util.isNullOrEmpty = function (in_value) {
		return (in_value === null || in_value === "");
	};

	/**
	 * 文字列をboolean型に変換
	 * @param {string} in_str 対象の文字列
	 * @param {*} [in_unexpectedValue] true/falseにできない場合に返す値
	 * @return {boolean} 引数がtrueの場合、true
	 */
	linda.util.toBoolean = function (in_str, in_unexpectedValue) {
		if (this.isUndef(in_unexpectedValue)) {
			in_unexpectedValue = null;
		}

		switch (in_str.toLowerCase()) {
			case "true":
				return true;
			case "false":
				return false;
		}

		return in_unexpectedValue;
	};

	/**
	 * クエリ文字列をオブジェクト化したものを取得
	 * @param {string} [in_qstr] クエリ文字列
	 * @return {Object} クエリ文字列をオブジェクト化したもの
	 */
	linda.util.getQueryString = function (in_qstr) {
		if (this.isUndefOrNull(in_qstr)) {
			in_qstr = location.search;
		}
		if (in_qstr.substr(0, 4) == "http") {
			let pos = in_qstr.indexOf("?");
			if (pos >= 0) {
				in_qstr = in_qstr.substr(pos);
			} else {
				in_qstr = "";
			}
		}
		if (in_qstr.substr(0, 1) == "?") {
			in_qstr = in_qstr.substr(1);
		}

		let obj = {};

		if (in_qstr.length > 0) {
			let arr = in_qstr.split("&");

			$.each(arr, function (idx, val) {
				let pair = val.split("=");

				if (pair.length > 1) {
					obj[pair[0]] = pair[1];
				}
			});
		}

		return obj;
	};

    /**
     * yyyy/MM/dd形式に変換した文字列を返します。
     * @param {any} date
     */
	linda.util.convertDateYMD =	function (in_date) {

        if (this.isNullOrEmpty(in_date)) return "";

        let dt = new Date(in_date);
        let y = dt.getFullYear();
        let m = ("00" + (dt.getMonth() + 1)).slice(-2);
        let d = ("00" + dt.getDate()).slice(-2);
        let result = y + "/" + m + "/" + d;
        return result;
    }

	/**
     * yyyyMMddHHmmss形式に変換した文字列を返します。
     */
	linda.util.getNowDateyyyyMMddHHmmss = function () {
	
        let dt = new Date();

		let y = dt.getFullYear();
		let M = ("00" + (dt.getMonth() + 1)).slice(-2);
		let d = ("00" + dt.getDate()).slice(-2);
		let H = ("00" + dt.getHours()).slice(-2);
		let m = ("00" + dt.getMinutes()).slice(-2);
		let s = ("00" + dt.getSeconds()).slice(-2);
		let result = y + M + d + H + m + s;
		return result;
	}

	/**
     * Base64文字列をBlobに変換する
     * @param {any} base64
     * @param {any} mime_ctype
     */
    linda.util.toBlob = function (base64, mime_ctype) {
        let bom = new Uint8Array([0xEF, 0xBB, 0xBF]);
        let bin = atob(base64.replace(/^.*,/, ''));
        let buffer = new Uint8Array(bin.length);
        for (let i = 0; i < bin.length; i++) {
            buffer[i] = bin.charCodeAt(i);
        }
        let blob = null
        try {
            blob = new Blob([bom, buffer.buffer], {
                type: mime_ctype,
            });
        } catch (e) {
            return false;
        }
        return blob;
    }

})(window.linda);

(function (linda) {
	linda.form = {};

	const fieldTypes = {
		UNKNOWN: ""
		, TEXT: "text"
		, TEXTAREA: "textarea"
		, INTEGER: "integer"
		, DOUBLE: "double"
		, DECIMAL: "decimal"
		, MONEY: "money"
		, DATETIME: "datetime"
		, BOOLEAN_RADIO_CELL: "boolean-radio-cell"
		, PICKLIST_CELL: "picklist-cell"
		, LOOKUP_CELL: "lookup-cell"
		, LOOKUP: "lookup"
	};

	const validatorTypes = {
		REQUIRED: "Required"
		, CUSTOM: "Custom"
	};


	/**
	 * フィールド関連情報オブジェクトの取得
	 * @param {string|Object} in_fieldName 対象のフィールド名
	 * @return {Object|null} フィールド関連情報オブジェクト
	 */
	linda.form.getFieldInfo = function (in_fieldName) {
		if ($.isPlainObject(in_fieldName)) {
			// フィールド関連情報オブジェクトと判断。そのまま返す
			return in_fieldName;
		}

		let jqField = $("#" + in_fieldName);
		let jqLabel = $("#" + in_fieldName + "_label");
		let jqCell = jqField.closest("td.cell");
		let jqInfo = jqCell.find("div.info");
		let jqCtrl = jqCell.find("div.control");

		if (jqField.length == 0) {
			return null;
		}

		// フィールドタイプ
		let type = fieldTypes.UNKNOWN;
		$.each(fieldTypes, function (key, value) {
			if (value.length == 0) {
				return true;
			}

			if (jqCell.hasClass(value)) {
				type = value;
				return false;
			}
		});

		let jqSection = jqCell.closest("table.section");
		let sectionName = jqSection.attr("data-name");
		let jqPanel = jqSection.closest("div.tab");
		let tabName = jqPanel.attr("data-name");
		let jqTab = jqPanel.prev("h2");

		// フィールド関連情報オブジェクト
		let fieldInfo = {
			fieldName: in_fieldName
			, jqField: jqField
			, jqLabel: jqLabel
			, jqCell: jqCell
			, jqInfo: jqInfo
			, jqCtrl: jqCtrl
			, type: type

			, jqSection: jqSection
			, sectionName: (linda.util.isUndefOrNull(sectionName) ? "" : sectionName)
			, jqTab: jqTab
			, jqPanel: jqPanel
			, tabName: (linda.util.isUndefOrNull(tabName) ? "" : tabName)
		};

		let jq;

		// フィールドタイプ個別の追加要素
		switch (fieldInfo.type) {
			case fieldTypes.DATETIME:
				// 日付
				fieldInfo.jqDispDate = fieldInfo.jqField.next("div").find("input");
				fieldInfo.jqCalender = fieldInfo.jqCtrl.find("span.input-group-addon");
				break;

			case fieldTypes.BOOLEAN_RADIO_CELL:
				// 2つのオプション
				fieldInfo.jqRadios = fieldInfo.jqField.find("input:radio");
				jq = $("#" + fieldInfo.fieldName + "_Value");
				if (jq.length == 0) {
					jq = $("<input type='hidden'>");
					//jq.attr("name", fieldInfo.jqRadios.eq(0).attr("name") + "_Value");
					jq.attr("name", fieldInfo.jqRadios.eq(0).attr("name"));
					jq.attr("id", fieldInfo.fieldName + "_Value");
					jq.prop("disabled", true);
					fieldInfo.jqCtrl.append(jq);
				}
				fieldInfo.jqRadioValue = jq;
				break;

			case fieldTypes.PICKLIST_CELL:
			case fieldTypes.LOOKUP_CELL:
				// オプションセット
				// 検索？
				jq = $("#" + fieldInfo.fieldName + "_Value");
				if (jq.length == 0) {
					jq = $("<input type='hidden'>");
					//jq.attr("name", fieldInfo.jqField.attr("name") + "_Value");
					jq.attr("name", fieldInfo.jqField.attr("name"));
					jq.attr("id", fieldInfo.fieldName + "_Value");
					jq.prop("disabled", true);
					fieldInfo.jqCtrl.append(jq);
				}
				fieldInfo.jqSelectValue = jq;
				break;

			case fieldTypes.LOOKUP:
				// 検索
				fieldInfo.jqDispName = fieldInfo.jqField.prev();
				fieldInfo.jqClearButton = fieldInfo.jqCtrl.find("button.clearlookupfield");
				fieldInfo.jqSearchButton = fieldInfo.jqCtrl.find("button.launchentitylookup");
				break;

		}

		return fieldInfo;
	};

	/**
	 * セクション関連情報オブジェクトの取得
	 * @param {string|Object} in_sectionName 対象のセクション名
	 * @return {Object|null} セクション関連情報オブジェクト
	 */
	linda.form.getSectionInfo = function (in_sectionName) {
		if ($.isPlainObject(in_sectionName)) {
			// セクション関連情報オブジェクトと判断。そのまま返す
			return in_sectionName;
		}

		let jqTable = $("table.section[data-name='" + in_sectionName + "']");
		let jqSection = jqTable.closest("fieldset");
		let jqLabel = jqSection.children("legend");

		if (jqSection.length == 0) {
			return null;
		}

		let jqPanel = jqSection.closest("div.tab");
		let tabName = jqPanel.attr("data-name");
		let jqTab = jqPanel.prev("h2");

		// セクション関連情報オブジェクト
		let sectionInfo = {
			sectionName: in_sectionName
			, jqTable: jqTable
			, jqSection: jqSection
			, jqLabel: jqLabel

			, jqTab: jqTab
			, jqPanel: jqPanel
			, tabName: (linda.util.isUndefOrNull(tabName) ? "" : tabName)
		};

		return sectionInfo;
	};

	/**
	 * タブ関連情報オブジェクトの取得
	 * @param {string|Object} in_tabName 対象のタブの名前
	 * @return {Object|null} タブ関連情報オブジェクト
	 */
	linda.form.getTabInfo = function (in_tabName) {
		if ($.isPlainObject(in_tabName)) {
			// タブ関連情報オブジェクトと判断。そのまま返す
			return in_tabName;
		}

		let jqPanel = $("div.tab[data-name='" + in_tabName + "']");
		let jqTab = jqPanel.prev("h2");

		if (jqTab.length == 0) {
			return null;
		}

		// タブ関連情報オブジェクト
		let tabInfo = {
			tabName: in_tabName
			, jqTab: jqTab
			, jqPanel: jqPanel
		};

		return tabInfo;
	};


	/**
	 * フィールドの値を取得
	 * @param {string|Object} in_fieldName 対象のフィールド名
	 * @return {string|null} 値
	 */
	linda.form.getFieldValue = function (in_fieldName) {
		let value = null;

		let fieldInfo = this.getFieldInfo(in_fieldName);
		if (fieldInfo == null) {
			return value;
		}
		in_fieldName = fieldInfo.fieldName;

		let jq;

		switch (fieldInfo.type) {
			case fieldTypes.TEXT:
			case fieldTypes.TEXTAREA:
			case fieldTypes.INTEGER:
			case fieldTypes.DOUBLE:
			case fieldTypes.DECIMAL:
			case fieldTypes.MONEY:
				// 1行テキスト
				// テキストエリア
				// 整数
				// 浮動小数点数
				// 10進数
				// 通貨型
				jq = fieldInfo.jqField;
				value = jq.val();
				break;

			case fieldTypes.DATETIME:
				// 日付
				jq = fieldInfo.jqDispDate;
				value = jq.val();
				break;

			case fieldTypes.BOOLEAN_RADIO_CELL:
				// 2つのオプション
				jq = fieldInfo.jqRadios.filter(":checked");
				value = jq.val();
				break;

			case fieldTypes.PICKLIST_CELL:
			case fieldTypes.LOOKUP_CELL:
				// オプションセット
				// 検索？
				jq = fieldInfo.jqField;
				value = jq.val();
				break;

			case fieldTypes.LOOKUP:
				// 検索
				jq = fieldInfo.jqField;
				value = jq.val();
				break;

			default:
				break;
		}

		return value;
	};

	/**
     * チェック済みのチェックボックスを取得する
     * @param {any} in_name
     */
    linda.form.getCheckList = function (in_name) {
        let checkList = [];
        $("input[name='" + in_name + "']:checked").each(function () {
            checkList.push($(this).val());
        });

        return checkList;
    }

	/**
	 * フィールドに値を設定
	 * @param {string|Object} in_fieldName 対象のフィールド名
	 * @param {string} in_value 値
	 * @param {Object} [in_params] その他パラメータ
	 */
	linda.form.setFieldValue = function (in_fieldName, in_value, in_params) {
		let fieldInfo = this.getFieldInfo(in_fieldName);
		if (fieldInfo == null) {
			return;
		}
		in_fieldName = fieldInfo.fieldName;

		if (linda.util.isUndefOrNull(in_params)) {
			in_params = {};
		}

		let jq;

		switch (fieldInfo.type) {
			case fieldTypes.TEXT:
			case fieldTypes.TEXTAREA:
			case fieldTypes.INTEGER:
			case fieldTypes.DOUBLE:
			case fieldTypes.DECIMAL:
			case fieldTypes.MONEY:
				// 1行テキスト
				// テキストエリア
				// 整数
				// 浮動小数点数
				// 10進数
				// 通貨型
				jq = fieldInfo.jqField;
				jq.val(in_value);
				break;

			case fieldTypes.DATETIME:
				// 日付
				jq = fieldInfo.jqDispDate;
				jq.val(in_value);
				jq.change();
				break;

			case fieldTypes.BOOLEAN_RADIO_CELL:
				// 2つのオプション
				if ($.type(in_value) === "boolean") {
					in_value = in_value ? "1" : "0";
				}
				jq = fieldInfo.jqRadios.filter("[value='" + in_value + "']");
				jq.prop("checked", true);
				break;

			case fieldTypes.PICKLIST_CELL:
			case fieldTypes.LOOKUP_CELL:
				// オプションセット
				// 検索？
				jq = fieldInfo.jqField;
				jq.val(in_value);
				break;

			case fieldTypes.LOOKUP:
				// 検索
				// ※ただし、名称はセットされない
				jq = fieldInfo.jqField;
				let jqName = $("#" + in_fieldName + "_name");
				let jqEntityName = $("#" + in_fieldName + "_entityname");

				let name = "";
				let entityName = "";

				if (in_value.length > 0) {
					/*
					let jqEntityGrid = fieldInfo.jqCtrl.find("div.entity-grid");
					let layout = linda.form.getEntityGridSelectedViewLayout(jqEntityGrid);
					entityName = layout.Configuration.EntityName;
					*/
					
					if (in_fieldName === "linda_approvalimplementuseridforedit") {
						entityName = "contact";
					}

					// パラメータから名称を取得
					if (!linda.util.isUndefOrNull(in_params.name)) {
						name = in_params.name;
					} else {
						name = "????";
					}
				}

				jq.val(in_value);
				jqName.val(name);
				jqEntityName.val(entityName);
				break;

			default:
				break;
		}
	};

    const filterTypes = {
        UNKNOWN: ""
        , TEXT: "entitylist-filter-option-text"
        , OPTIONSET: "checkbox"
    };

    /**
     * フィルター関連情報オブジェクトの取得
     * @param {any} in_jqFilter
     */
    linda.form.getFilterInfo = function (in_jqFilter) {
    
        let jqFilter = in_jqFilter;
        let jqLabel = jqFilter.find(".entitylist-filter-option-group-label");
        let jqOption = jqFilter.find(".entitylist-filter-option");
    
        if (jqOption.length == 0 || jqLabel.length == 0) {
    
            return null;
        }
    
        // フィルタータイプ
        let type = filterTypes.UNKNOWN;
        $.each(filterTypes, function (key, value) {
            if (value.length == 0) {
                return true;
            }
    
            if (jqOption.find("div").hasClass(value)) {
                type = value;
                return false;
            }
        });
    
        // フィルター関連情報オブジェクト
        let filterInfo = {
            jqLabel: jqLabel
            , jqOption: jqOption
            , type: type
            , name: jqLabel[0].innerText
        };
    
        // フィルタータイプ個別の値を取得
        switch (filterInfo.type) {
            case filterTypes.TEXT:
                // 1行テキスト、日付
                let jqText = jqOption.find(":text");
                if (jqText.length > 0) {
                    filterInfo.value = jqText[0].value;
                }
                break;
            case filterTypes.OPTIONSET:
                // オプションセット
                filterInfo.value = [];
                jqOption.each(function () {
                    
                    let jqCheckboxOption = $(this).find("label");
                    if (jqCheckboxOption.length > 0) {
                        
                        let jqCheckbox = jqCheckboxOption.find(":checkbox");
                        if(jqCheckbox.length > 0) {
                        
                            filterInfo.value.push(jqCheckboxOption[0].innerText + ":" + jqCheckbox[0].checked);
                        }
                    }
                });
                break;
        }
    
        return filterInfo
    };

    const selfMadeFilterTypes = {
        UNKNOWN: ""
        , TEXT: "text"
        , DATETIME: "datetime"
        , OPTIONSET: "optionset"
        , RADIO: "radio"
    };

    /**
    * フィルター関連情報オブジェクトの取得
    * @param {any} in_jqFilter
    */
    linda.form.getSelfMadeFilterInfo = function (in_jqFilter) {

        let jqFilter = in_jqFilter;
        let jqLabel = jqFilter.find(".entitylist-filter-option-group-label,.control-label");
        let jqControl = jqFilter.find(".form-control");
        let jqGroup = jqFilter.find(".form-group");

        if (jqLabel.length == 0) {

            return null;
        }

        // フィルタータイプ
        let type = selfMadeFilterTypes.UNKNOWN;
        if (jqControl.length == 0 && jqGroup.length == 0) {

            return null;
        }
        else if (jqControl.length == 0 && jqGroup.length > 0) {

            let jqGroupRadio = jqGroup.find("input[type='radio']");
            if (jqGroupRadio.length == 0) {

                type = selfMadeFilterTypes.OPTIONSET;
            }
            else {

                type = selfMadeFilterTypes.RADIO;
            }
        }
        else if (jqControl.length > 0 && jqGroup.length == 0) {

            type = selfMadeFilterTypes.TEXT;
        }
        else {

            type = selfMadeFilterTypes.DATETIME;
        }

        // フィルター関連情報オブジェクト
        let filterInfo = {
            jqLabel: jqLabel
            , jqControl: jqControl
            , jqGroup: jqGroup
            , type: type
            , name: jqLabel[0].innerText
        };

        // フィルタータイプ個別の値を取得
        switch (filterInfo.type) {
            case selfMadeFilterTypes.TEXT:
                // 1行テキスト
                filterInfo.value = jqControl[0].value;
                break;
            case selfMadeFilterTypes.DATETIME:
                // 日付
                filterInfo.value = jqControl[0].value;
                break;
            case selfMadeFilterTypes.OPTIONSET:
                // オプションセット
                filterInfo.value = [];
                let jqCustomControl = jqGroup.find(".custom-control");
                jqCustomControl.each(function () {

                    let jqCustomControlLabel = $(this).find(".custom-control-label");
                    let jqCustomControlInput = $(this).find(".custom-control-input");
                    if (jqCustomControlLabel.length > 0 && jqCustomControlInput.length > 0) {

                        filterInfo.value.push(jqCustomControlLabel[0].innerText + ":" + jqCustomControlInput[0].checked);
                    }
                });
                break;
            case selfMadeFilterTypes.RADIO:
                // 2つのオプション
                let jqSelectedRadio = jqGroup.find("input:checked").parent();
                if (jqSelectedRadio.length > 0) {

                    filterInfo.value = jqSelectedRadio[0].innerText;
                }

                break;
        }

        return filterInfo;
    };

	//--------------------------------------------------------------------------

	/**
	 * フィールドが表示されているか（個別のvisible値で判断）
	 * @param {string|Object|jQuery} in_fieldName 対象のフィールド名またはコントロールオブジェクト
	 * @return {boolean} 表示されている場合true、非表示の場合false
	 */
	linda.form.getFieldVisible = function (in_fieldName) {
		let jqCtrl = null;

		if (in_fieldName instanceof jQuery) {
			jqCtrl = in_fieldName;
		} else {
			let fieldInfo = this.getFieldInfo(in_fieldName);
			if (fieldInfo != null) {
				jqCtrl = fieldInfo.jqCtrl;
				in_fieldName = fieldInfo.fieldName;
			}
		}

		if (linda.util.isUndefOrNull(jqCtrl) || jqCtrl.length == 0) {
			return false;
		}

		// display:noneかで判断
		// ※タブやセクションが非表示でフィールド自体は見えなくても、個別に非表示にしてなければ表示扱い
		//   タブやセクションの表示/非表示に関わらず、常に見えないなら非表示扱い
		return (jqCtrl.css("display") != "none");
	};

	/**
	 * フィールドが表示されているか（見た目で判断）
	 * @param {string|Object|jQuery} in_fieldName 対象のフィールド名またはコントロールオブジェクト
	 * @return {boolean} 表示されている場合true、非表示の場合false
	 */
	linda.form.isFieldDisplayed = function (in_fieldName) {
		let jqCtrl = null;

		if (in_fieldName instanceof jQuery) {
			jqCtrl = in_fieldName;
		} else {
			let fieldInfo = this.getFieldInfo(in_fieldName);
			if (fieldInfo != null) {
				jqCtrl = fieldInfo.jqCtrl;
				in_fieldName = fieldInfo.fieldName;
			}
		}

		if (linda.util.isUndefOrNull(jqCtrl) || jqCtrl.length == 0) {
			return false;
		}

		// 現在の見た目のみで判断
		// ※タブやセクションが非表示ならフィールドも見えないので、非表示扱い
		return jqCtrl.is(":visible");
	};

	/**
	 * フィールドの表示/非表示
	 * @param {string|Object} in_fieldName 対象のフィールド名
	 * @param {boolean} in_isVisible 表示する場合true、非表示にする場合false
	 */
	linda.form.setFieldVisible = function (in_fieldName, in_isVisible) {
		let fieldInfo = this.getFieldInfo(in_fieldName);
		if (fieldInfo == null) {
			return;
		}
		in_fieldName = fieldInfo.fieldName;

		fieldInfo.jqInfo.toggle(in_isVisible);
		fieldInfo.jqCtrl.toggle(in_isVisible);
	};

	/**
	 * セクションが表示されているか（個別のvisible値で判断）
	 * @param {string|Object|jQuery} in_sectionName 対象のセクション名またはセクションオブジェクト
	 * @return {boolean} 表示されている場合true、非表示の場合false
	 */
	linda.form.getSectionVisible = function (in_sectionName) {
		let jqSection = null;

		if (in_sectionName instanceof jQuery) {
			jqSection = in_sectionName;
		} else {
			let sectionInfo = this.getSectionInfo(in_sectionName);
			if (sectionInfo != null) {
				jqSection = sectionInfo.jqSection;
				in_sectionName = sectionInfo.sectionName;
			}
		}

		if (linda.util.isUndefOrNull(jqSection) || jqSection.length == 0) {
			return false;
		}

		// display:noneかで判断
		// ※タブが非表示でセクション自体は見えなくても、個別に非表示にしてなければ表示扱い
		//   タブの表示/非表示に関わらず、常に見えないなら非表示扱い
		return (jqSection.css("display") != "none");
	};

	/**
	 * セクションが表示されているか（見た目で判断）
	 * @param {string|Object|jQuery} in_sectionName 対象のセクション名またはセクションオブジェクト
	 * @return {boolean} 表示されている場合true、非表示の場合false
	 */
	linda.form.isSectionDisplayed = function (in_sectionName) {
		let jqSection = null;

		if (in_sectionName instanceof jQuery) {
			jqSection = in_sectionName;
		} else {
			let sectionInfo = this.getSectionInfo(in_sectionName);
			if (sectionInfo != null) {
				jqSection = sectionInfo.jqSection;
				in_sectionName = sectionInfo.sectionName;
			}
		}

		if (linda.util.isUndefOrNull(jqSection) || jqSection.length == 0) {
			return false;
		}

		// 現在の見た目のみで判断
		// ※タブが非表示ならセクションも見えないので、非表示扱い
		return jqSection.is(":visible");
	};

	/**
	 * セクションの表示/非表示
	 * @param {string|Object} in_sectionName 対象のセクション名
	 * @param {boolean} in_isVisible 表示する場合true、非表示にする場合false
	 */
	linda.form.setSectionVisible = function (in_sectionName, in_isVisible) {
		let sectionInfo = this.getSectionInfo(in_sectionName);
		if (sectionInfo == null) {
			return;
		}
		in_sectionName = sectionInfo.sectionName;

		sectionInfo.jqSection.toggle(in_isVisible);
	};

	/**
	 * タブが表示されているか
	 * @param {string|Object|jQuery} in_tabName 対象のタブの名前またはタブオブジェクト
	 * @return {boolean} 表示されている場合true、非表示の場合false
	 */
	linda.form.getTabVisible = function (in_tabName) {
		let jqTab = null;

		if (in_tabName instanceof jQuery) {
			jqTab = in_tabName;
		} else {
			let tabInfo = this.getTabInfo(in_tabName);
			if (tabInfo != null) {
				jqTab = tabInfo.jqTab;
				in_tabName = tabInfo.tabName;
			}
		}

		if (linda.util.isUndefOrNull(jqTab) || jqTab.length == 0) {
			return false;
		}

		return jqTab.is(":visible");
	};

	/**
	 * タブの表示/非表示
	 * @param {string|Object} in_tabName 対象のタブの名前
	 * @param {boolean} in_isVisible 表示する場合true、非表示にする場合false
	 */
	linda.form.setTabVisible = function (in_tabName, in_isVisible) {
		let tabInfo = this.getTabInfo(in_tabName);
		if (tabInfo == null) {
			return;
		}
		in_tabName = tabInfo.tabName;

		let isTabOpened = this.isTabOpened(tabInfo);

		// タブ
		tabInfo.jqTab.toggle(in_isVisible);

		// パネル
		if (in_isVisible) {
			if (isTabOpened) {
				tabInfo.jqPanel.toggle(true);
			}
		} else {
			tabInfo.jqPanel.toggle(false);
		}

		// イベント発行
		$("body").trigger("changed_tab_visible", in_tabName);
	};

	/**
	 * タブのパネル部を開く
	 * @param {string|Object} in_tabName 対象のタブの名前
	 * @param {boolean} [in_isAnimation] アニメーション表示する場合true
	 */
	linda.form.openTab = function (in_tabName, in_isAnimation) {
		if (linda.util.isUndefOrNull(in_isAnimation)) {
			in_isAnimation = true;
		}

		let tabInfo = this.getTabInfo(in_tabName);
		if (tabInfo == null) {
			return;
		}
		in_tabName = tabInfo.tabName;

		let isTabVisible = this.getTabVisible(tabInfo);
		let jqPanel = tabInfo.jqPanel;

		if (isTabVisible) {
			if (in_isAnimation) {
				jqPanel.slideDown();
			} else {
				jqPanel.show();
			}
		}

		tabInfo.jqTab.removeClass("tabclosed");
	};

	/**
	 * タブのパネル部を閉じる
	 * @param {string|Object} in_tabName 対象のタブの名前
	 * @param {boolean} [in_isAnimation] アニメーション表示する場合true
	 */
	linda.form.closeTab = function (in_tabName, in_isAnimation) {
		if (linda.util.isUndefOrNull(in_isAnimation)) {
			in_isAnimation = true;
		}

		let tabInfo = this.getTabInfo(in_tabName);
		if (tabInfo == null) {
			return;
		}
		in_tabName = tabInfo.tabName;

		let isTabVisible = this.getTabVisible(tabInfo);
		let jqPanel = tabInfo.jqPanel;

		if (isTabVisible) {
			if (in_isAnimation) {
				jqPanel.slideUp();
			} else {
				jqPanel.hide();
			}
		}

		tabInfo.jqTab.addClass("tabclosed");
	};

	/**
	 * タブのパネル部が開いているか
	 * @param {string|Object|jQuery} in_tabName 対象のタブの名前またはタブオブジェクト
	 * @return {boolean} 開いている場合true、閉じている場合false
	 */
	linda.form.isTabOpened = function (in_tabName) {
		let jqTab = null;

		if (in_tabName instanceof jQuery) {
			jqTab = in_tabName;
		} else {
			let tabInfo = this.getTabInfo(in_tabName);
			if (tabInfo != null) {
				jqTab = tabInfo.jqTab;
				in_tabName = tabInfo.tabName;
			}
		}

		if (linda.util.isUndefOrNull(jqTab) || jqTab.length == 0) {
			return false;
		}

		return !jqTab.hasClass("tabclosed");
	};

	//--------------------------------------------------------------------------

	/**
	 * フィールドの読み取り専用を設定/解除する
	 * @param {string|Object} in_fieldName 対象のフィールド名
	 * @param {boolean} in_isReadonly 読み取り専用にする場合true、解除する場合false
	 */
	linda.form.setFieldReadonly = function (in_fieldName, in_isReadonly) {
		let fieldInfo = this.getFieldInfo(in_fieldName);
		if (fieldInfo == null) {
			return;
		}
		in_fieldName = fieldInfo.fieldName;

		let jq;
		let jq2;
		let jq3;
		let value;

		switch (fieldInfo.type) {
			case fieldTypes.TEXT:
			case fieldTypes.TEXTAREA:
			case fieldTypes.INTEGER:
			case fieldTypes.DOUBLE:
			case fieldTypes.DECIMAL:
			case fieldTypes.MONEY:
				// 1行テキスト
				// テキストエリア
				// 整数
				// 浮動小数点数
				// 10進数
				// 通貨型
				jq = fieldInfo.jqField;
				if (in_isReadonly) {
					jq.addClass("readonly").prop("readonly", true);
					jq.addClass("disabled").prop("disabled", true);
				} else {
					jq.removeClass("readonly").prop("readonly", false);
					jq.removeClass("disabled").prop("disabled", false);
				}
				break;

			case fieldTypes.DATETIME:
				// 日付
				jq = fieldInfo.jqField;
				jq2 = fieldInfo.jqDispDate;
				jq3 = fieldInfo.jqCalender;
				if (in_isReadonly) {
					jq.addClass("readonly").prop("readonly", true);
					jq.addClass("disabled").prop("disabled", true);
					jq2.addClass("readonly").prop("readonly", true);
					jq2.addClass("disabled").prop("disabled", true);
					let parent = jq2.parent();
					parent.css("display", "block");
					jq3.hide();
				} else {
					jq.removeClass("readonly").prop("readonly", false);
					jq.removeClass("disabled").prop("disabled", false);
					jq2.removeClass("readonly").prop("readonly", false);
					jq2.removeClass("disabled").prop("disabled", false);
					let parent = jq2.parent();
					parent.css("display", "table");
					jq3.show();
				}
				break;

			case fieldTypes.BOOLEAN_RADIO_CELL:
				// 2つのオプション
				jq = fieldInfo.jqField;
				jq2 = fieldInfo.jqRadios;
				jq3 = fieldInfo.jqRadioValue;
				if (in_isReadonly) {
					jq.addClass("readonly").prop("readonly", true).prop("disabled", true);
					jq2.prop("disabled", true);
					value = this.getFieldValue(fieldInfo);
					jq3.prop("disabled", false).val(value);
				} else {
					jq.removeClass("readonly").prop("readonly", false).prop("disabled", false);
					jq2.prop("disabled", false);
					jq3.prop("disabled", true);
				}
				break;

			case fieldTypes.PICKLIST_CELL:
			case fieldTypes.LOOKUP_CELL:
				// オプションセット
				// 検索？
				jq = fieldInfo.jqField;
				jq3 = fieldInfo.jqSelectValue;
				if (in_isReadonly) {
					jq.addClass("readonly").prop("readonly", true).prop("disabled", true);
					value = this.getFieldValue(fieldInfo);
					jq3.prop("disabled", false).val(value);
				} else {
					jq.removeClass("readonly").prop("readonly", false).prop("disabled", false);
					jq3.prop("disabled", true);
				}
				break;

			case fieldTypes.LOOKUP:
				// 検索
				jq = fieldInfo.jqClearButton;
				jq2 = fieldInfo.jqSearchButton;
				jq3 = fieldInfo.jqDispName;
				if (in_isReadonly) {
					jq.prop("disabled", true);
					jq.hide();
					jq2.prop("disabled", true);
					jq2.hide();
					jq3.prop("disabled", true);
					jq3.nextAll("div").css("display", "none");
					let parent = jq3.parent();
					parent.css("display", "block");
				} else {
					jq.prop("disabled", false);
					jq.show();
					jq2.prop("disabled", false);
					jq2.show();
					jq3.prop("disabled", false);
					jq3.nextAll("div").css("display", "");
					let parent = jq3.parent();
					parent.css("display", "table");
				}

				break;

			default:
				break;
		}
	};

	/**
     * 検索フィールドのボタンの読み取り専用を設定/解除する
     * @param {string|Object} in_selector 対象のセレクタ名
     */
	linda.form.setSearchFieldSelectBtnStatus = function (in_selector) {
		let jqBtn = $("#" + in_selector + " .modal-footer").find("button[aria-label='選択']");
        if ($("#" + in_selector + " tbody tr").hasClass("selected info")) {
			// いずれかの項目がチェックされている場合
            jqBtn.removeClass("readonly").prop("readonly", false);
            jqBtn.removeClass("disabled").prop("disabled", false);
        } else {
			// いずれの項目もチェックされていない場合
            jqBtn.addClass("readonly").prop("readonly", true);
            jqBtn.addClass("disabled").prop("disabled", true);
        }
	}

	//--------------------------------------------------------------------------

	/**
	 * フィールドにツールチップを設定
	 * @param {string} in_fieldName 対象のフィールド名
	 * @param {string} in_msg 表示するメッセージ
	 * @param {string} [in_placement] ツールチップの表示位置
	 */
	linda.form.setTooltip = function (in_fieldName, in_msg, in_placement) {
		if (linda.util.isUndefOrNull(in_placement)) {
			in_placement = "top";
		}

		let jqField = $("#" + in_fieldName);

		jqField.attr("title", in_msg);

		jqField.tooltip({
			placement: in_placement
		});
	};

	/**
	 * フィールドにプレースホルダーを設定
	 * @param {string} in_fieldName 対象のフィールド名
	 * @param {string} in_msg 表示するメッセージ
	 */
	linda.form.setPlaceholder = function (in_fieldName, in_msg) {
		let jqField = $("#" + in_fieldName);

		jqField.attr("placeholder", in_msg);
	};

	/**
	 * フィールドにクラスを追加
	 * @param {string|Object} in_fieldName 対象のフィールド名
	 * @param {string} in_class 追加するクラス
	 */
	linda.form.addFieldCtrlClass = function (in_fieldName, in_class) {
		let fieldInfo = this.getFieldInfo(in_fieldName);
		if (fieldInfo == null) {
			return;
		}
		in_fieldName = fieldInfo.fieldName;

		fieldInfo.jqCtrl.addClass(in_class);
	};

	/**
	 * フィールドからクラスを削除
	 * @param {string|Object} in_fieldName 対象のフィールド名
	 * @param {string} in_class 削除するクラス
	 */
	linda.form.removeFieldCtrlClass = function (in_fieldName, in_class) {
		let fieldInfo = this.getFieldInfo(in_fieldName);
		if (fieldInfo == null) {
			return;
		}
		in_fieldName = fieldInfo.fieldName;

		fieldInfo.jqCtrl.removeClass(in_class);
	};

	/**
	 * 指定したクラスを持つフィールドを検索
	 * @param {string} in_class クラス
	 * @return {Array.<string>} 合致するフィールド名
	 */
	linda.form.searchFieldsByCtrlClass = function (in_class) {
		let ret = [];

		let jqCtrls = $("div.control." + in_class);

		jqCtrls.each(function () {
			let jqCtrl = $(this);
			let jqCell = jqCtrl.closest("td.cell");
			let jqInfo = jqCell.find("div.info");
			let jqLabel = jqInfo.find("label[id]")

			if (jqLabel.length == 0) {
				return;
			}

			let id = jqLabel.attr("id");
			let surfix = "_label";

			if (id.slice(-surfix.length) != surfix) {
				return;
			}

			id = id.slice(0, -surfix.length);

			ret.push(id);
		});

		return ret;
	};

	/**
	 * 指定要素を透明/透明解除する
	 * @param {jQuery} in_jq 対象のオブジェクト
	 * @param {boolean} in_isTransparent 透明する場合true、透明解除にする場合false
	 */
	linda.form.setTransparent = function (in_jq, in_isTransparent) {
		if (in_isTransparent) {
			in_jq.addClass("transparent");
		} else {
			in_jq.removeClass("transparent");
		}
	};

	/**
	 * 画面全体を覆うマスクを生成する
	 */
	linda.form.createMask = function () {
		if ($("#divMask").length > 0) {
			return;
		}

		let jqBody = $("body");
		let jqMask = $("<div id='divMask'>")
			.append("<div class='lds-spinner'><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><p></p></div>");

		jqBody.css("position", "relative");
		jqBody.append(jqMask);
	};

	/**
	 * 通常のemail型のtextboxの場合、mailerが立ち上がるため、仮の枠を設定する。
	 * 併せて、仮の枠に入力があった場合、元のテキストボックスに入力値を範囲するイベントを設定する。
	 */
	linda.form.createMailTextBox = function (in_id) {
		let jqEmail = $("<input value='' maxlength='128' id='" + in_id + "_copy' class='text form-control mailcopy' type='text'>");
        $("#" + in_id).after(jqEmail);
        linda.form.setFieldValue(in_id + "_copy", linda.form.getFieldValue(in_id));
        $("#" + in_id).hide();
        jqEmail.on("change", function () {
            console.debug("★change copy" + $(this).attr("id") + " to " + $(this).prev("input").attr("id"));
            linda.form.setFieldValue($(this).prev("input").attr("id"), linda.form.getFieldValue($(this).attr("id")));
        });
	}

	/**
	 * マスクを表示する
	 */
	linda.form.showMask = function () {
		$("#divMask").show();
	};

	/**
	 * マスクを消す
	 */
	linda.form.hideMask = function () {
		$("#divMask").hide();
	};

	/**
	 * コンテンツ部を表示（透明を解除）する
	 * @param {jQuery} in_jqContent 対象のコンテンツ
	 */
	linda.form.showContent = function (in_jqContent) {
		
		let jqBody = $("body");
		if (linda.util.isUndefOrNull(in_jqContent)) {
			jqBody.children().each(function() {
				$this = $(this);
				if (Math.round($this.css("opacity")*100)/100 == "0.01") {
					$this.css("opacity", "1");
					linda.form.setTransparent($this, false);
				}
			});

		} else {

			if (in_jqContent.length > 0) {
				in_jqContent.css("opacity", "1");
				linda.form.setTransparent(in_jqContent, false);
			}
		}

		// Maskを取り除く
		linda.form.hideMask();

	};

	/**
	 * 指定した読み取り専用のURL型フィールドについて、ターゲットを設定する
	 * @param {string} in_fieldName 対象のフィールド名（URL型フィールド）
	 * @param {string} [in_target] ターゲット
	 */
	linda.form.setUrlFieldTarget = function (in_fieldName, in_target) {
		if (linda.util.isUndefOrNull(in_target)) {
			in_target = "";
		}

		let fieldInfo = this.getFieldInfo(in_fieldName);
		let jqLink = fieldInfo.jqCtrl.find("a");

		if (in_target.length > 0) {
			jqLink.attr("target", in_target);
		} else {
			jqLink.removeAttr("target");
		}
	};

	/**
	 * 指定した読み取り専用の検索フィールドについて、リンクを設定する
	 * @param {string} in_fieldName 対象のフィールド名（検索フィールド）
	 * @param {string} in_url 開くURLのプレフィックス
	 * @param {string} [in_target] ターゲット
	 */
	linda.form.setLookupFieldRedirectLink = function (in_fieldName, in_url, in_target) {
		if (linda.util.isUndefOrNull(in_target)) {
			in_target = "";
		}

		let fieldInfo = this.getFieldInfo(in_fieldName);
		let id = this.getFieldValue(fieldInfo);
		let jqName = $("#" + in_fieldName + "_name");

		if (linda.util.isNullOrEmpty(id) || jqName.length == 0) {
			return;
		}

		let linkFieldName = in_fieldName + "_link";
		let jqLink = $("#" + linkFieldName);

		if (jqLink.length == 0) {
			let jqDiv = $("<div />").addClass("form-control").prop("readonly", true);
			jqLink = $("<a />").attr("id", linkFieldName).addClass("text-primary");
			jqDiv.append(jqLink);

			jqName.hide();
			fieldInfo.jqCtrl.append(jqDiv);
		}

		let url = in_url + id;
		let name = jqName.val();

		jqLink.attr("href", url).text(name);
		if (in_target.length > 0) {
			jqLink.attr("target", in_target);
		} else {
			jqLink.removeAttr("target");
		}
	};

	/**
	 * モーダルダイアログのタイトルを設定
	 * @param {jQuery} in_jqModal 対象のモーダルダイアログ
	 * @param {string} in_title タイトル
	 */
	linda.form.setModalDialogTitle = function (in_jqModal, in_title) {
		let jqTitle = in_jqModal.find(".modal-title");

		jqTitle.text(in_title);
		jqTitle.attr("title", in_title);
	};

	/**
	 * エンティティフォームのレイアウト定義を取得
	 * @return {Object|null} レイアウト定義
	 */
	linda.form.getEntityFormLayout = function () {
		let layout = null;

		let jqEntityForm = $("div.entity-form");

		if (jqEntityForm.length > 0) {
			let jqEntityLayoutConfig = $("#" + jqEntityForm.attr("id") + "_EntityLayoutConfig");

			if (jqEntityLayoutConfig.length > 0) {
				layout = jqEntityLayoutConfig.data("form-layout");
			}
		}

		return layout;
	};

	/**
	 * エンティティフォームの更新後メッセージ画面かどうかを取得
	 * @return {boolean} 更新後画面の場合true、通常画面の場合false
	 */
	linda.form.isEntityFormOnSuccess = function () {
		let jqControl = $("[id^='EntityFormControl_']");
		let jqFormPanel = $("#EntityFormPanel");

		return (jqControl.length > 0 && jqFormPanel.length == 0);
	};


	/**
	 * 指定位置までアニメーションスクロール
	 * @param {jQuery} in_jq 対象のオブジェクト
	 */
	linda.form.animationScroll = function (in_jq) {
		if (linda.util.isUndefOrNull(in_jq) || in_jq.length == 0) {
			return;
		}

		let position = in_jq.offset().top;

		$("html, body").animate({ scrollTop: position });
	};

	/**
	 * 送信直前処理を設定
	 * @param {Function} in_newValidFunc 送信直前処理
	 */
	linda.form.setEntityFormClientValidateFunction = function (in_newValidFunc) {
		// もともと処理がある場合、保持する
		// ※entityFormClientValidateはグローバル変数
		let orgValidFunc = entityFormClientValidate;

		entityFormClientValidate = function () {
			let ret = true;

			if (!linda.util.isUndef(orgValidFunc) && $.isFunction(orgValidFunc)) {
				ret = orgValidFunc.apply(this, arguments);
			}
			if (!ret) {
				return false;
			}

			if (!linda.util.isUndef(in_newValidFunc) && $.isFunction(in_newValidFunc)) {
				ret = in_newValidFunc.apply(this, arguments);
			}
			if (!ret) {
				return false;
			}

			return true;
		};
	};

	//--------------------------------------------------------------------------

	/**
	 * 指定したグリッドのすべてのレイアウト定義を取得
	 * @param {jQuery} in_jqEntityGrid 対象のグリッド（div.entity-grid）
	 * @return {Array.<Object>} すべてのレイアウト定義（設定されているビューの数分の配列）
	 */
	linda.form.getEntityGridLayouts = function (in_jqEntityGrid) {
		let layouts = in_jqEntityGrid.data("view-layouts");

		return layouts;
	};

	/**
	 * 指定したグリッドのすべてのレイアウト定義を差し替え
	 * @param {jQuery} in_jqEntityGrid 対象のグリッド（div.entity-grid）
	 * @param {Array.<Object>} in_layouts すべてのレイアウト定義（設定されているビューの数分の配列）
	 */
	linda.form.setEntityGridLayouts = function (in_jqEntityGrid, in_layouts) {
		in_jqEntityGrid.data("view-layouts", in_layouts);
	};

	/**
	 * 指定したグリッドの現在選択されているビューのインデックスを取得
	 * @param {jQuery} in_jqEntityGrid 対象のグリッド（div.entity-grid）
	 * @return {number} インデックス
	 */
	linda.form.getEntityGridActiveLayoutIndex = function (in_jqEntityGrid) {
		let layouts = this.getEntityGridLayouts(in_jqEntityGrid);
		let selectedViewId = in_jqEntityGrid.data("selected-view");
		let activeLayoutIndex = 0;

		if (!linda.util.isUndefOrNull(selectedViewId) && selectedViewId !== false && selectedViewId.length > 0) {
			$.each(layouts, function (index, lo) {
				if (lo.Id.toLowerCase().indexOf(selectedViewId.toLowerCase()) != -1) {
					activeLayoutIndex = index;
					return false;
				}
			});
		}

		return activeLayoutIndex;
	};

	/**
	 * 指定したグリッドの現在選択されているビューのレイアウト定義を取得
	 * @param {jQuery} in_jqEntityGrid 対象のグリッド（div.entity-grid）
	 * @return {Object} レイアウト定義
	 */
	linda.form.getEntityGridSelectedViewLayout = function (in_jqEntityGrid) {
		let layouts = this.getEntityGridLayouts(in_jqEntityGrid);
		let activeLayoutIndex = this.getEntityGridActiveLayoutIndex(in_jqEntityGrid);

		if (!linda.util.isUndefOrNull(layouts) && activeLayoutIndex < layouts.length) {
			return layouts[activeLayoutIndex];
		} else {
			return null;
		}
	};

	/**
	 * 指定したグリッドの現在選択されているビューのレイアウト定義を差し替え
	 * @param {jQuery} in_jqEntityGrid 対象のグリッド（div.entity-grid）
	 * @param {Object} in_layout レイアウト定義
	 */
	linda.form.setEntityGridSelectedViewLayout = function (in_jqEntityGrid, in_layout) {
		let layouts = this.getEntityGridLayouts(in_jqEntityGrid);
		let activeLayoutIndex = this.getEntityGridActiveLayoutIndex(in_jqEntityGrid);

		if (activeLayoutIndex < layouts.length) {
			layouts[activeLayoutIndex] = in_layout;
			this.setEntityGridLayouts(in_jqEntityGrid, layouts);
		}
	};

	/**
	 * 指定したグリッド、URL型フィールドについて、ターゲットを設定する
	 * @param {jQuery} in_jqEntityGrid 対象のグリッド（div.entity-grid）
	 * @param {string} in_fieldName 対象のフィールド名（URL型フィールド）
	 * @param {string} [in_target] ターゲット
	 */
	linda.form.setEntityGridUrlFieldTarget = function (in_jqEntityGrid, in_fieldName, in_target) {
		if (linda.util.isUndefOrNull(in_target)) {
			in_target = "";
		}

		let jqLinks = in_jqEntityGrid.find("div.view-grid td[data-attribute='" + in_fieldName + "'] a");

		jqLinks.attr("target", in_target);
	};

	/**
	 * 指定したグリッド、検索フィールドについて、リンクを設定する
	 * @param {jQuery} in_jqEntityGrid 対象のグリッド（div.entity-grid）
	 * @param {string} in_fieldName 対象のフィールド名（検索フィールド）
	 * @param {string} in_url 開くURLのプレフィックス
	 * @param {string} [in_target] ターゲット
	 */
	linda.form.setEntityGridLookupFieldRedirectLink = function (in_jqEntityGrid, in_fieldName, in_url, in_target) {
		if (linda.util.isUndefOrNull(in_target)) {
			in_target = "";
		}

		let jqTds = in_jqEntityGrid.find("div.view-grid td[data-attribute='" + in_fieldName + "']");

		jqTds.each(function () {
			let jqTd = $(this);
			let value = jqTd.data("value");

			if (!linda.util.isUndefOrNull(value) && !linda.util.isUndefOrNull(value.Id)) {
				let url = in_url + value.Id;
				let text = ""
				if (jqTd.text() == "") {
					text = "(件名なし)";
				} else {
					text = jqTd.text();
				}
				let jqLink = $("<a />").attr("href", url).text(text);

				if (in_target.length > 0) {
					jqLink.attr("target", in_target);
				} else {
					jqLink.removeAttr("target");
				}

				jqTd.empty();
				jqTd.append(jqLink);
			}
		});
	};

	/**
	 * 指定したグリッドの商品コードについて、
	 * C1の商品詳細画面へのリンクを設定する
	 * @param {jQuery} in_jqEntityGrid 対象のグリッド（div.entity-grid）
	 * @param {string} in_fieldName 対象のフィールド名（商品コード）
	 */
	linda.form.setEntityGridProductLink = function (in_jqEntityGrid, in_fieldName) {

		let jqTds = in_jqEntityGrid.find("div.view-grid td[data-attribute='" + in_fieldName + "']");

		jqTds.each(function () {
			let jqTd = $(this);
			let value = jqTd.text();

			if (!linda.util.isUndefOrNull(value) && value != "") {
				let url = linda.settings.c1ProductDetailUrl + value;

				let jqLink = $("<a />").attr("href", url).text(value);
				jqLink.attr("target", value);

				jqTd.empty();
				jqTd.append(jqLink);
			}
		});
	};

	//--------------------------------------------------------------------------

	/**
	 * ページバリデーターが使用可能か
	 * @return {boolean} 使用可能な場合true、無効な場合false
	 */
	linda.form.isValidPageValidator = function () {
		return !(linda.util.isUndef(window.Page_Validators));
	};

	linda.form._createValidator = function (in_validatorType, in_fieldName, in_errMsg) {
		let fieldID = in_fieldName;
		let labelID = fieldID + "_label";
		let validatorID = in_fieldName + in_validatorType + "Validator";
		let errMsgID = validatorID + "_errmsg";

		let validator = document.createElement("span");

		validator.style.display = "none";
		validator.id = validatorID;
		validator.controltovalidate = in_fieldName;
		validator.errormessage = "<a id='" + errMsgID + "' href='#'>" + in_errMsg + "</a>";
		validator.validationGroup = "";
		validator.initialvalue = "";

		validator.validatorType = in_validatorType;
		validator.fieldID = fieldID;
		validator.labelID = labelID;
		validator.errMsgID = errMsgID;
		validator.isActive = true;

		return validator;
	};

	linda.form._attachValidator = function (in_validator, in_isActive) {
		if (!linda.form.isValidPageValidator()) {
			return null;
		}

		window.Page_Validators.push(in_validator);

		this.activateValidator(in_validator, in_isActive);

		(function (validator) {
			$("body").on("click", "#" + validator.errMsgID, function (in_event) {
				in_event.preventDefault();

				let fieldInfo = linda.form.getFieldInfo(validator.fieldID);

				if (!linda.form.isTabOpened(fieldInfo.tabName)) {
					linda.form.openTab(fieldInfo.tabName, false);
				}

				scrollToAndFocus(validator.labelID, validator.fieldID);
			});
		})(in_validator);
	};

	/**
	 * バリデーターの有効/無効化
	 * @param {element} in_validator 対象のバリデーター
	 * @param {boolean} in_isActive 有効にする場合true、無効にする場合false
	 */
	linda.form.activateValidator = function (in_validator, in_isActive) {
		in_validator.isActive = in_isActive;

		if (in_validator.validatorType == validatorTypes.REQUIRED) {
			let fieldInfo = this.getFieldInfo(in_validator.fieldID);

			if (in_isActive) {
				fieldInfo.jqInfo.addClass("required");
			} else {
				fieldInfo.jqInfo.removeClass("required");
			}
		}
	};


	linda.form._isValidationTargetField = function (in_validator) {
		if (!in_validator.isActive) {
			return false;
		}

		let fieldInfo = linda.form.getFieldInfo(in_validator.fieldID);
		if (fieldInfo == null) {
			return false;
		}

		// 明示的にフィールド、セクション、タブを非表示にしている場合、チェックの対象外とする
		if (!linda.form.getFieldVisible(fieldInfo)
			|| (fieldInfo.jqSection.length > 0 && !linda.form.getSectionVisible(fieldInfo.jqSection))
			|| (fieldInfo.jqTab.length > 0 && !linda.form.getTabVisible(fieldInfo.jqTab))) {
			return false;
		}

		return true;
	};

	function evaluationFunction_Required() {
		let isValidationTargetField = linda.form._isValidationTargetField(this);

		if (!isValidationTargetField) {
			return true;
		}

		let val = linda.form.getFieldValue(this.fieldID);
		if (linda.util.isNullOrEmpty(val)) {
			return false;
		}

		return true;
	};


	linda.form._pushValidator = function (in_validatorType, in_fieldName, in_errMsg, in_function, in_isActive) {
		if (!linda.form.isValidPageValidator()) {
			return null;
		}

		if (linda.util.isUndefOrNull(in_isActive)) {
			in_isActive = true;
		}

		let validator = this._createValidator(in_validatorType, in_fieldName, in_errMsg);

		validator.evaluationfunction = in_function;

		this._attachValidator(validator, in_isActive);

		return validator;
	};

	/**
	 * 必須入力チェックバリデーターの登録
	 * @param {string} in_fieldName 対象のフィールド名
	 * @param {string} in_errMsg エラー時のメッセージ
	 * @param {boolean} [in_isActive] 有効にする場合true、無効にする場合false
	 * @return {element} 作成されたバリデーター
	 */
	linda.form.pushRequiredValidator = function (in_fieldName, in_errMsg, in_isActive) {
		return this._pushValidator(validatorTypes.REQUIRED, in_fieldName, in_errMsg, evaluationFunction_Required, in_isActive);
	};

	/**
	 * カスタムバリデーターの登録
	 * @param {string} in_fieldName 対象のフィールド名
	 * @param {string} in_errMsg エラー時のメッセージ
	 * @param {Function} in_function チェック関数
	 * @param {boolean} [in_isActive] 有効にする場合true、無効にする場合false
	 * @return {element} 作成されたバリデーター
	 */
	linda.form.pushCustomValidator = function (in_fieldName, in_errMsg, in_function, in_isActive) {
		return this._pushValidator(validatorTypes.CUSTOM, in_fieldName, in_errMsg, in_function, in_isActive);
	};

	function evaluationFunction_Prohibited() {
		let val = linda.form.getFieldValue(this.fieldID);
		let regex = new RegExp(/</);
		if (regex.test(val)) {
			return false;
		}

		return true;
	};

	/**
	 * 禁止文字入力チェックバリデーターの登録
	 * @param {boolean} [in_isActive] 有効にする場合true、無効にする場合false
	 */
	linda.form.pushProhibitedValidator = function (in_isActive) {
		$(".text.form-control").not(".disabled, .mailcopy, .lookup").each(function(i, o){
			let fieldInfo = linda.form.getFieldInfo(o.id);
			linda.form.pushCustomValidator(o.id, fieldInfo.jqLabel.text() + "に禁止文字「<」が入力されています。", evaluationFunction_Prohibited, in_isActive);
		});

		$(".textarea.form-control").not(".disabled, .mailcopy, .lookup").each(function(i, o){
			let fieldInfo = linda.form.getFieldInfo(o.id);
			linda.form.pushCustomValidator(o.id, fieldInfo.jqLabel.text() + "に禁止文字「<」が入力されています。", evaluationFunction_Prohibited, in_isActive);
		});
	}

	/**
	 * 特価希望時入力項目チェックバリデーターの登録
	 */
	linda.form.pushSpecialPriceValidator = function (in_isActive) {
		linda.form.pushCustomValidator("linda_specialpriceinput", $("#linda_specialpriceinput_label").text() + "を入力してください。", evaluationFunction_SpecialPrice, in_isActive);
	}

    /**
     * 特価希望のカスタムバリデーション
     */
    function evaluationFunction_SpecialPrice() {

        // 明示的に特価希望を非表示にしている場合、チェック不要 (=チェックOK)
        var fieldInfo = linda.form.getFieldInfo("linda_hopespecial");
        if (!linda.form.getFieldVisible(fieldInfo)
            || (fieldInfo.jqSection.length > 0 && !linda.form.getSectionVisible(fieldInfo.jqSection))
            || (fieldInfo.jqTab.length > 0 && !linda.form.getTabVisible(fieldInfo.jqTab))) {
            return true;
        }

        // 特価希望でない場合チェック不要 (=チェックOK)
        if (linda.form.getFieldValue("linda_hopespecial") != "1") {
            return true;
        }

        let input = $("#linda_specialpriceinput").val();

        // 空白, スペースのみ, テンプレート文言のままの場合エラー
        if (linda.util.isNullOrEmpty(input.trim()) || input.replace(/\r|\n|\r\n/g, "\r\n") == linda.form.promptSpecialPrice()) {
            return false;
        }

        return true;
    }

	/**
	 * バリデーターのエラーメッセージの更新
	 * @param {element} in_validator 対象のバリデーター
	 * @param {string} in_errMsg エラー時のメッセージ
	 */
	linda.form.updateErrorMessage = function (in_validator, in_errMsg) {
		var errMsgID = in_validator.errMsgID;
		in_validator.errormessage = "<a id='" + errMsgID + "' href='#'>" + in_errMsg + "</a>";
	}

	/**
     * 特価希望の初期文面
     */
    linda.form.promptSpecialPrice = function () {
		const NEW_LINE = "\r\n";
        let prompt = "";
        prompt += "＜案件情報＞" + NEW_LINE;
        prompt += "案件背景　：" + NEW_LINE;
        prompt += "商流 【必須】　：" + NEW_LINE;
        prompt += "案件種類 【必須】　：　入札　or　見積合わせ" + NEW_LINE;
        prompt += "希望仕切・競合仕切 【必須】　：" + NEW_LINE;
        prompt += "競合情報　：" + NEW_LINE;
        prompt += "エンドユーザー会社住所　：" + NEW_LINE;
        prompt += NEW_LINE;
        prompt += "＜商品情報＞" + NEW_LINE;
        prompt += "製品型番　：　(上記の見積希望内容欄に入力されていない場合はご記入願います)" + NEW_LINE;
        prompt += "納品時期(納品日) 【必須】　：" + NEW_LINE;
        prompt += "納品方法　：　一括　or　分納" + NEW_LINE;
        prompt += "　※ご希望の商品によっては別途追加情報提供を依頼させて頂く場合がございます。";
        return prompt;
    }

    /**
     * 添付ファイル転記用のテンプレート
	 * @param {} [in_note]
	 * @param {string} [in_label]
	 * @return {element}
     */
    linda.form.attachmentFileTemplate = function (in_note, in_label) {
        let template = "";
        template += "<fieldset><table role='presentation' class='section'>";
        template += "<colgroup><col style='width:33.3%;'><col style='width:33.3%;'><col style='width:33.3%;'><col></colgroup>";
        template += "<tbody><tr>";
        template += "<td colspan='1' rowspan='1' class='clearfix cell text form-control-cell'>";
        template += "<div class='info'>";
        template += "<label for='" + in_label + "' id='" + in_label + "_label' readonly='readonly'>";
        template += "添付ファイル";
        template += "</label>";
        template += "<div class='attachment alert alert-block clearfix'>";
        template += "<div class='link pull-left'>";
        template += "<span class='fa fa-file' aria-hidden='true' style='color:#333333;'></span>";
        template += "<a href='" + $(in_note).attr("data-attachmenturl") + "' target='_blank' style='color: #2780e3;'>";
        template += $(in_note).attr("data-attachmentfilename") + "(" + $(in_note).attr("data-attachmentfilesize") + ")";
        template += "</a>";
        template += "</div>";
        template += "</div>";
        template += "</div>";
        template += "</td>";
        template += "<td colspan='1' rowspan='1' class='clearfix cell'></td>";
        template += "<td colspan='1' rowspan='1' class='clearfix cell'></td>";
        template += "</tr></tbody>";
        template += "</table></fieldset>";
        return template;
    }

	/**
	 * エンティティリストフィルターの入力項目をクリアする
	 */
	linda.form.clearEntitylistFilters =	function () {
		let jqFilters = $("#entitylist-filters");

		jqFilters.find(":text").val("");
		jqFilters.find("select").prop("selectedIndex", -1);
		jqFilters.find(":radio").prop("checked", false);
		jqFilters.find(":checked").prop("checked", false);

		$("#txtFreeword").change();
	}

	/**
	 * 問い合わせ一覧用のCookieを初期化する
	 */
	linda.form.initCookieOfContact = function () {

        console.debug("[ckcontact] cookie init...");
        let ckcontact = {
            txtfreeword: null,
            title: null,
            incidentcategory: null,
            incidentstatus: null,
            responsibleperson: null,
            createdfrom: null,
            createdto: null
        };
        $.cookie("ckcontact", JSON.stringify(ckcontact), { path: "/" });

	}

	/**
	 * 注文一覧用のCookieを初期化する
	 */
	linda.form.initCookieOfSalesOrder = function () {

        console.debug("[cksalesorder] cookie init...");
        let cksalesorder = {
            txtfreeword: null,
            csquotenumber: null,
            ordernumber: null,
            name: null,
            status: null,
            applicationformstatus: null,
            orderdatefrom: null,
            orderdateto: null,
            searchoption1: null,
            searchoption2: null,
            searchoption3: null,
            salesperson: null,
			orderwideuseitem1: null,
			orderwideuseitem2: null,
			orderwideuseitem3: null
        };
        $.cookie("cksalesorder", JSON.stringify(cksalesorder), { path: "/" });
        localStorage.removeItem('favConditionList');
	
	}

	/**
	 * 明細DL用のCookieを初期化する
	 */
	linda.form.initCookieOfQuoteDetail = function () {

        console.debug("[ckquotedetail] cookie init...");
        let ckquotedetail = {
            txtfreeword: null,
            quoteno: null,
            quotebranchnumber: null,
            itemcode: null,
            makername: null,
            createdatefrom: null,
            createdateto: null,
            searchmakercode: null,
            searchoption1: null,
            searchoption2: null,
            searchoption3: null
        };
        $.cookie("ckquotedetail", JSON.stringify(ckquotedetail), { path: "/" });
		localStorage.removeItem('searchQuoteDetailDLCondition');

	}

	/**
	 * 見積一覧用のCookieを初期化する
	 */
	linda.form.initCookieOfQuote = function () {

	    console.debug("[ckquote] cookie init...");
        let ckquote = {
            txtfreeword: null,
            contactname: null,
            salesrepname: null,
            enduser: null,
            dealerstatus: null,
            quoterequestdatefrom: null,
            quoterequestdateto: null,
            updatefrom: null,
            updateto: null,
            dealerdivisioncode: null,
            dealerdivisionname: null,
            searchoption1: null,
            searchoption2: null,
            searchoption3: null,
			name: null,
			quotes: null,
			branch: null,
			quoteforsearch: null
        };
        $.cookie("ckquote", JSON.stringify(ckquote), { path: "/" });
		localStorage.removeItem('searchCondition');
	}

	/**
	 * 依頼状況確認用のCookieを初期化する
	 */
	linda.form.initCookieOfQuoteRequest = function () {

	    console.debug("[ckquoterequest] cookie init...");
        let ckquoterequest = {
            txtfreeword: null,
            title: null,
            responsibleperson: null,
            salesperson: null,
            enduser: null,
            incidentstatus: null,
            quoterequestdatefrom: null,
            quoterequestdateto: null,
            searchoption1: null,
            searchoption2: null,
            searchoption3: null
        };
        $.cookie("ckquoterequest", JSON.stringify(ckquoterequest), { path: "/" });
		localStorage.removeItem('reqSitSearchCondition');
	}

	/**
	 * 出荷一覧用のCookieを初期化する
	 */
	linda.form.initCookieOfShipping = function () {

        console.debug("[ckshipping] cookie init...");
        let ckcontact = {
            txtfreeword: null,
            dealerorderno: null,
            voucherno: null,
            orderno: null,
            letterno: null,
            shippingdatefrom: null,
            shippingdateto: null
        };
        $.cookie("ckshipping", JSON.stringify(ckcontact), { path: "/" });

	}

	/**
	 * 注文一括承認用のCookieを初期化する
	 */
	linda.form.initCookieOfSalesorderBulkApproval = function () {

        console.debug("[ckbulkapproval] cookie init...");
        let ckbulkapproval = {
            txtfreeword: null,
            csquotenumber: null,
            ordernumber: null,
            name: null,
            salesperson: null,
            orderdatefrom: null,
            orderdateto: null,
        };
        $.cookie("ckbulkapproval", JSON.stringify(ckbulkapproval), { path: "/" });

	}

	/**
	 * 納品先設定用のCookieを初期化する
	 */
	linda.form.initCookieOfMyDestination = function () {

	    console.debug("[ckmydestination] cookie init...");
        let ckmydestination = {
            txtfreeword: null
        };
        $.cookie("ckmydestination", JSON.stringify(ckmydestination), { path: "/" });

	}

	/**
	 * 荷送先設定用のCookieを初期化する
	 */
	linda.form.initCookieOfMyShipper = function () {

	    console.debug("[ckmyshipper] cookie init...");
        let ckmyshipper = {
            txtfreeword: null
        };
        $.cookie("ckmyshipper", JSON.stringify(ckmyshipper), { path: "/" });

	}
	
	/**
     * 指定したkeyのCookieを取得する
     * @param {string} in_key cookieのkey
     */
    linda.form.getCookie = function (in_key) {
        return JSON.parse($.cookie(in_key));
    }

	/**
	 * 日付入力欄のフォーカスアウト時に下限値判定を行うイベントを設定する
	 */
	linda.form.setDatetimepickerBlurEvent = function () {
		let jqBody = $("body");

		// 日付入力欄の下限値 (1753/01/01)
		let lowerDate = new Date(1753, 0, 1);
		// 日付入力欄の上限値 (9999/12/30)
		let upperDate = new Date(9999, 11, 30);

		// 日付入力欄のフォーカスアウト時
		jqBody.on("blur", ".input-append.input-group.datetimepicker .form-control", function () {

			let ymd = $(this).val().split("/");
			$.each(ymd, function(index, value) {
				ymd[index] = parseInt(value, 10);
			});
			let inputDate = new Date();
			inputDate.setFullYear(ymd[0], ymd[1] - 1, ymd[2])
			inputDate.setHours(0, 0, 0, 0);

			// 下限値以前または上限値以降の日付が入力された場合クリア
			if (inputDate < lowerDate || inputDate > upperDate) {
				$(this).val("");
				$(this).parent().parent().find(".datetime.form-control").val(""); // 隠しフィールド
			}
		});
	}

	/**
	 * 見積依頼先部門の設定
	 */
	linda.form.setDefaultQuoteOrderTargetDept = function(in_orderTargetId) {

        // ユーザーの取引先企業
        let customerID = linda.user.parentCustomerId;
        if (linda.util.isNullOrEmpty(customerID)) {
            // 終了
            return;
        }

        let url = "/_odata/accounts";
        let filter = "accountid eq (guid'" + customerID + "')";

        url += "?" + "$filter=" + filter;

        linda.ajax.requestAPI("GET", url)
            .then(function (in_result) {
                let account = in_result.json.value;

                if (account.length == 1) {

                    account = account[0];
                    let salesGroupMl = account.linda_sbcssalesgroupml;
                    let licenseGroupMl = account.linda_sbcslicensegroupml;

                    // C&S営業担当グループMLが空の場合貴社営業担当を削除
                    if (linda.util.isNullOrEmpty(salesGroupMl)) {
                        $("#" + in_orderTargetId + " option[value=" + linda.enums.quoteOrderTargetDept.RESPONSIBLE_SALES + "]").remove();
                    }

                    // C&S契約案件担当グループMLが空の場合MSライセンス包括契約案件担当を削除
                    if (linda.util.isNullOrEmpty(licenseGroupMl)) {
                        $("#" + in_orderTargetId + " option[value=" + linda.enums.quoteOrderTargetDept.MS_LICENSE_RESPONSIBLE + "]").remove();
                    }

                    let optionCount = $("#" + in_orderTargetId).children().length;
                    // ドロップダウンの項目数が1つ (空白項目を含めて2つ) 以下の場合
                    if (optionCount <= 2) {
                        // 項目をセットして読み取り専用にする
                        $("#" + in_orderTargetId).prop("selectedIndex", optionCount - 1);
                        linda.form.setFieldReadonly(in_orderTargetId, true);
                    }

                }
            });
	}

    /**
     * ページ上部にアラートメッセージを表示
     * @param {any} in_message
     */
    linda.form.showAlertMessage = function (in_message) {
        $(".alert.alert-info.clearfix.alert-danger").remove();
        if (in_message != null) {
            let header = $("div.page-heading");
            let message = $("<div class='alert alert-info clearfix alert-danger'>")
                .append($("<span class='fa fa-info-circle' aria-hidden=true>"))
                .append("<span class='xrm-editable-text xrm-attribute' data-languagecontext='日本語'><span class='xrm-attribute-value-encoded xrm-attribute-value'>")
                .append(in_message);
            header.append(message);
            linda.form.animationScroll(header);
        }
    }

    /**
     * ページ上部にアラートメッセージのリストを表示
     * @param {any} in_messageList
     */
    linda.form.showAlertMessageList = function (in_messageList) {
        $("div.alert.alert-info.clearfix.alert-danger").remove();
        if (in_messageList.length > 0) {
            let header = $("div.page-heading");
            let messageList = $("<div class='alert alert-info clearfix alert-danger'>")
                .append("<ul style='list-style:none;margin-left:0;padding-left:0'>");

            in_messageList.forEach(function (value) {
                messageList.find("ul").append("<li>" + value + "</li>");
            });
            header.append(messageList);
            linda.form.animationScroll(header);
        }
    }

    /**
     * 日付フィルタ条件(From-To)の大小が正しいかチェックする
     * @param {string} datefrom_filterid
     * @param {string} dateto_filterid
	 * @return {boolean} 日付の大小が正しい場合true、正しくない場合false
     */
    linda.form.isDateFromToValid = function (datefrom_filterid, dateto_filterid) {
        // 日付(FROM)
        var datefrom = linda.util.convertDateYMD($("input.form-control[name='" + datefrom_filterid + "']").val());
        // 日付(TO)
        var dateto = linda.util.convertDateYMD($("input.form-control[name='" + dateto_filterid + "']").val());

        var ret = true;
        if (!linda.util.isNullOrEmpty(datefrom) && !linda.util.isNullOrEmpty(dateto)) {
            var from = new Date(datefrom);
            var to = new Date(dateto);
            if (from > to) {
                ret = false;
            }
        }
        return ret;
    }

	/**
	 * フリーワード設定
	 */
	linda.form.setEntityListFilterFieldFreeWordTextBox = function (tooltip_text, isActive) {
		if (typeof isActive === 'undefined') {
		    isActive = true;
			} 
		if (isActive) {
		    // フリーワード項目の作成（ルールチップ含む）
            let jqFilters = $("ul#entitylist-filters");
            let jqFilter = $("<li class='entitylist-filter-option-group'>");
            let jqFilterLabel = $("<label class='entitylist-filter-option-group-label h4'>");
            let jqFilterUl = $("<ul class='list-unstyled' role='presentation' data-pagesize='6'>");
            let jqFilterLi = $("<li class='entitylist-filter-option'>");
            let jqDiv = $("<div class='input-group entitylist-filter-option-text'>");
            let jqText = $("<input type='text' id='txtFreeword' class='form-control'>");
            
            jqFilter.append(jqFilterLabel).append(jqFilterUl);
            jqFilterUl.append(jqFilterLi);
            jqFilterLabel.text("フリーワード");
            jqDiv.append(jqText);
            jqFilterLi.append(jqDiv);

            jqText.attr("title", tooltip_text);
            jqText.tooltip();

            jqFilters.prepend(jqFilter);
		}

		// 偽ボタン作成
        let jqSearchBtn = $("button.btn-entitylist-filter-submit");
		let jqDummyBtn = $("<button type='button' id='btn_search' title='検索' class='btn btn-primary'>検索</button>");
        jqSearchBtn.after(jqDummyBtn);
        jqSearchBtn.hide();

		let jqBody = $("body");
		jqBody.on("click", "#btn_search", function() {
		    
			if (isActive) {
                // フリーワードのあいまい検索条件設定処理
			    let jqSearchText = $("div.entitylist-search input");
			    jqSearchText.val("*" + $("#txtFreeword").val() + "*");
            }
			
			// 日付項目の検索条件設定
			$.each($("div.datetimepicker"), function(i, el){
                let inputDate = $(el).find("input").val();
                if (inputDate === undefined || inputDate == "" ) {
                    $(el).prev().val('');
                } else { 
                    $(el).prev().val(inputDate);
                }
            });

			// 検索実行
			$("button.btn-entitylist-filter-submit").click();

		});

		$("body").on("loaded", "div.entity-grid.entitylist", function () {
			let jqSearchDiv = $("div.entitylist-search");
			jqSearchDiv.hide();
		});
	}

})(window.linda);

(function (linda) {
	linda.dialog = {};

	linda.dialog.params = null;
	linda.dialog.returnValue = null;

	linda.dialog.jqIfm = null;



})(window.linda);

(function (linda) {
	linda.ajax = {};

	linda.ajax.ver = "";
	linda.ajax.scripts = [];

	/**
	 * WebAPIの実行
	 * @param {string} in_action HTTPメソッド名
	 * @param {string} in_uri 実行URL
	 * @param {Object} [in_data] 送信データ
	 * @param {Object} [in_params] 設定パラメータ
	 * @return {Promise} Promiseオブジェクト
	 */
	linda.ajax.requestAPI = function (in_action, in_uri, in_data, in_params) {
		let deferred = $.Deferred();

		let params = $.extend({
			async: true
			, isFormattedValue: false
			, maxPageSize: null
		}, in_params || {});

		let prefer = "";

		let settings = {
			url: encodeURI(in_uri)
			, method: in_action			// POST PATCH PUT GET DELETE
			, cache: false
			, async: params.async
			, contentType: "application/json; charset=utf-8"
			, data: JSON.stringify(in_data)
			, dataType: "json"
			, dataFilter: function(data) {
				// タブ対応し、再変換
				var retData = data;
				// タブ対応
				if (data.search(/\t/g)) {
					retData = retData.replace(/\t/g, " ");
				}

				// 改行対応
				if (retData.search("<br />")) {
				    retData = retData.replace(/\r?\n/g, '');
				}
				return retData;
			}
		};

		settings.headers = {
			"Accept": "application/json"
			//, "OData-MaxVersion": "4.0"
			//, "OData-Version": "4.0"
		};
		if (prefer.length > 0) {
			settings.headers["Prefer"] = prefer;
		}

		let result = {
			isSuccess: false
			, json: null
			, jqXHR: null
			, status: null
			, error: null
			, errorJson: null
		};

		$.ajax(settings)
			.then(function (data, textStatus, jqXHR) {
				result.isSuccess = true;
				result.json = data;
				result.jqXHR = jqXHR;
				result.status = textStatus;

				deferred.resolve(result);
			}
			, function (jqXHR, textStatus, errorThrown) {
				result.isSuccess = false;
				result.json = null;
				result.jqXHR = jqXHR;
				result.status = textStatus;
				result.error = errorThrown;
				if (!linda.util.isUndefOrNull(jqXHR.responseJSON) && !linda.util.isUndef(jqXHR.responseJSON.error)) {
					result.errorJson = jqXHR.responseJSON.error;
				}

				deferred.reject(result);
			});

		return deferred.promise();
	};

	/**
	 * システム設定の取得
	 * @param {string|Array.<string>} in_names キー
	 * @return {Promise} Promiseオブジェクト
	 */
	linda.ajax.getSystemConfig = function (in_names) {
		let deferred = $.Deferred();

		if (!$.isArray(in_names)) {
			in_names = [in_names];
		}

		let url = "/_odata/linda_systemconfigs";

		let filter = "";
		for (let idx = 0; idx < in_names.length; idx++) {
			if (filter.length > 0) {
				filter += " or ";
			}
			filter += "(linda_name eq '" + in_names[idx] + "')";
		}

		url += "?" + "$filter=" + filter;

		let configs = null;

		linda.ajax.requestAPI("GET", url)
			.then(function (in_result) {
				configs = in_result.json.value;
			})
			.then(function () {
				deferred.resolve(configs);
			}
			, function () {
				deferred.reject();
			});

		return deferred.promise();
	};

	/**
	 * 取引先企業の取得
	 * @return {Promise} Promiseオブジェクト
	 */
	linda.ajax.getAccount = function() {
        let deferred = $.Deferred();
        let accountId = linda.user.parentCustomerId;
        if (linda.util.isNullOrEmpty(accountId)) {
            deferred.reject();
            return deferred.promise();
        }
        let url = "/_odata/accounts";
        let filter = "accountid eq (guid'" + accountId + "')";

        url += "?" + "$filter=" + filter;

        let account = null;
        linda.ajax.requestAPI("GET", url)
            .then(function (in_result) {
                account = in_result.json.value;
            })
            .then(function () {
                deferred.resolve(account);
            }
                , function () {
                    deferred.reject(account);
                });
        return deferred.promise();
    }

	/**
	 * 取引先企業のGuidを指定して取引先企業の情報を取得する
     * @param {any} in_accountId
	 * @return {Promise} Promiseオブジェクト
	 */
	linda.ajax.getAccountByAccountId = function(in_accountId) {
        let deferred = $.Deferred();
        if (linda.util.isNullOrEmpty(in_accountId)) {
            deferred.reject();
            return deferred.promise();
        }
        let url = "/_odata/accounts";
        let filter = "accountid eq (guid'" + in_accountId + "')";

        url += "?" + "$filter=" + filter;

        let account = null;
        linda.ajax.requestAPI("GET", url)
            .then(function (in_result) {
                account = in_result.json.value;
            })
            .then(function () {
                deferred.resolve(account);
            }
                , function () {
                    deferred.reject(account);
                });
        return deferred.promise();
    }

	/**
	 * 取引先企業の取引先企業番号を指定して取引先企業の情報を取得する
     * @param {any} in_accountNumber
	 * @return {Promise} Promiseオブジェクト
	 */
	linda.ajax.getAccountByAccountNumber = function(in_accountNumber) {
        let deferred = $.Deferred();
        if (linda.util.isNullOrEmpty(in_accountNumber)) {
            deferred.reject();
            return deferred.promise();
        }
        let url = "/_odata/accounts";
        let filter = "accountnumber eq '" + in_accountNumber + "'";

        url += "?" + "$filter=" + filter;

        let account = null;
        linda.ajax.requestAPI("GET", url)
            .then(function (in_result) {
                account = in_result.json.value;
            })
            .then(function () {
                deferred.resolve(account);
            }
                , function () {
                    deferred.reject(account);
                });
        return deferred.promise();
    }

	/**
     * CRMのトークンを取得します。
     */
	linda.ajax.getToken = function () {

        let deferred = $.Deferred();

		// Token取得
        let token = "";
        $.ajax({
            url: linda.settings.getTokenUrl,
            type: 'POST'
        })
            .then( function (data) {
                token = data;

				deferred.resolve(token);
            }
			    , function () {
                    deferred.reject(token);
                });

        return deferred.promise();
    }

	//--------------------------------------------------------------------------

	/**
	 * jsスクリプトのロード
	 * @param {Object} [in_document] Documentオブジェクト
	 * @param {Array.<string>} [in_scripts] スクリプトのパス
	 * @param {string} [in_ver] スクリプトのバージョン
	 * @return {Promise} Promiseオブジェクト
	 */
	linda.ajax.loadScripts = function (in_document, in_scripts, in_ver) {
		let deferred = $.Deferred();

		if (linda.util.isUndefOrNull(in_document)) {
			in_document = document;
		}
		if (linda.util.isUndefOrNull(in_scripts)) {
			in_scripts = this.scripts;
		}
		if (!$.isArray(in_scripts)) {
			in_scripts = [in_scripts];
		}
		if (linda.util.isUndefOrNull(in_ver)) {
			in_ver = this.ver;
		}

		let fragment = in_document.createDocumentFragment();
		let cnt = 0;

		for (let idx = 0; idx < in_scripts.length; idx++) {
			let url = in_scripts[idx];
			if (in_ver.length > 0) {
				url += (url.indexOf("?") >= 0 ? "&" : "?");
				url += "ver=" + in_ver;
			}

			let script = in_document.createElement("script");
			script.type = "text/javascript";
			//script.async = true;
			script.src = url;
			script.addEventListener("load", function (e) {
				cnt++;

				if (cnt >= in_scripts.length) {
					deferred.resolve();
				}
			}, false);

			fragment.appendChild(script);
		}

		let head = in_document.getElementsByTagName("head")[0];
		head.appendChild(fragment);

		return deferred.promise();
	};



})(window.linda);

(function (linda) {
	linda.logger = {};

	//--------------------------------------------------------------------------
	// Method
	//--------------------------------------------------------------------------

    /**
     * ログ出力用の操作時間を変換した文字列を返します。
     * @return {string} システム日時
     */
    linda.logger.getOperationDateTime = function () {

        let dt = new Date();

        let y = dt.getFullYear();
        let M = ("00" + (dt.getMonth() + 1)).slice(-2);
        let d = ("00" + dt.getDate()).slice(-2);
        let H = ("00" + dt.getHours()).slice(-2);
        let m = ("00" + dt.getMinutes()).slice(-2);
        let s = ("00" + dt.getSeconds()).slice(-2);
        let ms = ("000" + dt.getMilliseconds()).slice(-3);
        let result = y + "-" + M + "-" + d + " " + H + ":" + m + ":" + s + "." + ms;
        return result;
    };
	
    /**
     * ApplicationInsightsにログメッセージを送信します。
     * @param {any} in_processKbn
     * @param {any} in_processName
     * @param {any} in_parameter
     */
    linda.logger.sendLogMessage = function (in_processKbn, in_processName, in_parameter) {

        if (typeof appInsights === 'undefined') {

            return;
        }

        let msg = {
            ControlSystem: "CRM_PORTAL",
            Level: "INFO",
            SystemId: "Linda_D365Sales",
            UserId: linda.user.linda_userid,
            Date: linda.logger.getOperationDateTime(),
            ProcessKbn: in_processKbn,
            ProcessName: in_processName,
            Parameter: in_parameter,
            PageURL: document.URL
        };

        appInsights.trackTrace({ message: JSON.stringify(msg) });

    }

    /**
     * エンティティリストにログイベントを設定
     */
    linda.logger.setEntityListLogEvent = function () {

		// 共通
		linda.logger.setCommonButtonLogEvent();
    }

    /**
     * 検索フィルターのパラメータを取得
     */
    linda.logger.getEntityListFiltersParameter = function () {

        let params = [];

        let jqFilters = $("li.entitylist-filter-option-group");

        jqFilters.each(function() {
		    
			// フィルターの関連情報を取得
			let filterInfo = linda.form.getFilterInfo($(this));
			if (filterInfo != null) {

			    params.push("[" + filterInfo.name + "]=" + filterInfo.value);
			}
        });

        return params.join(",");
    }

    /**
     * 自作フィルターのパラメータを取得
     */
    linda.logger.getSelfMadeFiltersParameter = function () {

        let params = [];

        let jqFilters = $("#detail-search2").find("[class^='col-md']");

        jqFilters.each(function() {
		    
			// フィルターの関連情報を取得
			let filterInfo = linda.form.getSelfMadeFilterInfo($(this));
			if (filterInfo != null) {

			    params.push("[" + filterInfo.name + "]=" + filterInfo.value);
			}
        });

        return params.join(",");
    }

	/**
     * エンティティフォームにログイベントを設定
     */
	linda.logger.setEntityFormEvent = function () {

		// 確認モーダル
        linda.logger.setEntityFormModalEvent("#modal-submit");

		// ワークフローボタン
		linda.logger.setEntityFormWorkflowEvent();

		// 送信ボタン
		linda.logger.setEntityFormSubmitEvent();

		// 共通系
		linda.logger.setCommonButtonLogEvent();
    }

	/**
     * エンティティフォームのサブグリッドモーダルにイベントを設定
     */
	linda.logger.setEntityFormSubgridModalEvent = function () {
	    
		// ワークフローボタン
		linda.logger.setEntityFormSubgridModalWorkflowEvent();

		// 送信ボタン
		linda.logger.setEntityFormSubgridModalSubmitEvent();
	}

    /**
     * エンティティフォームのモーダルにイベントを設定
     * @param {any} in_selecter
     */
    linda.logger.setEntityFormModalEvent = function (in_selecter) {

        let jqModal = $(in_selecter);
        if (jqModal.length == 0) {

            return;
        }

        let jqOkButton = $(in_selecter).find("button.primary");
        let jqDialogOk = $("<button type='button' id='btn_dialogOk' title='OK' class='btn btn-default btn-dummy'>OK</button>");

        // 既存のOKボタンを非表示
        jqOkButton.hide();
        // ダミーのOKボタンを表示
        jqOkButton.after(jqDialogOk);

        jqDialogOk.on("click", function () {

			if (linda.user.linda_jobclasscd == linda.enums.jobClassCd.INTERNAL_USER) {
				
				// 確認ダイアログを閉じる
				$(in_selecter).modal("hide");
				// 社内確認用権限の場合、機能制限モーダルを表示
			    $("#modal-feature-limitation").modal("show");
			    return;
			}

            $(this).prop("disabled", true);
			
			let jqModalTitle = $(in_selecter).find(".modal-title");
            let processKbn = jqModalTitle[0].innerText;

            // ログの出力
            let params = linda.logger.getEntityFormParameter();
            let pageTitle = document.title;
            linda.logger.sendLogMessage(processKbn, pageTitle, params);

            // 非表示のOKボタンをクリック
            jqOkButton.click();
        });
    }

	/**
     * エンティティフォームのワークフローボタンにログイベントを設定
     */
    linda.logger.setEntityFormWorkflowEvent = function () {

        let jqWorkflowButton = $(".workflow-link.btn:visible");

        if (jqWorkflowButton.length == 0) {

            return;
        }

        jqWorkflowButton.each(function () {
            let jqDummyButton = $("<button type='button' class='workflow-link btn-default btn btn-dummy'></button>");
            jqDummyButton.text($(this).text());
            $(this).after(jqDummyButton);
            $(this).hide();

            jqDummyButton.on("click", function () {

                let jqPrevButton = $(this).prev("button");
                if (jqPrevButton.length == 0) {

                    return;
                }
                
                if (linda.user.linda_jobclasscd == linda.enums.jobClassCd.INTERNAL_USER) {
                
                    // 社内確認用権限の場合、機能制限モーダルを表示
                    $("#modal-feature-limitation").modal("show");
                    return;
                }

                // ログの出力
                let processKbn = jqPrevButton.text();
                let pageTitle = document.title;
                linda.logger.sendLogMessage(processKbn, pageTitle, "");

                // ワークフローボタンをクリック
                jqPrevButton.click();
            });
        });
    }

	/**
     * エンティティフォームのサブグリッドモーダルのワークフローボタンにイベントを設定
     */
	linda.logger.setEntityFormSubgridModalWorkflowEvent = function () {

        let jqWorkflowButton = $(".workflow-link.btn:visible");

        if (jqWorkflowButton.length == 0) {

            return;
        }

        jqWorkflowButton.each(function () {
            let jqDummyButton = $("<button type='button' class='workflow-link btn-default btn btn-dummy'></button>");
            jqDummyButton.text($(this).text());
            $(this).after(jqDummyButton);
            $(this).hide();

            jqDummyButton.on("click", function () {

                let jqPrevButton = $(this).prev("button");
                if (jqPrevButton.length == 0) {

                    return;
                }
                
                if (linda.dialog.params.jobClassCd == linda.enums.jobClassCd.INTERNAL_USER) {
                
                    // 社内確認用権限の場合、機能制限モーダルを表示
                    $("#modal-feature-limitation", parent.document).modal("show");
                    return;
                }

                // TODO: ログの出力部分は未対応

                // ワークフローボタンをクリック
                jqPrevButton.click();
            });
        });
	}

    /**
     * エンティティフォームの送信にイベントを設定
     */
    linda.logger.setEntityFormSubmitEvent = function () {

        let jqModal = $("#modal-submit");
        if (jqModal.length > 0) {

            // モーダル側でログ出力するため不要
            return;
        }

        let jqSubmit = $("#InsertButton,#UpdateButton:visible");
        if (jqSubmit.length == 0) {

            return;
        }

        jqSubmit.each(function () {

            let jqDummyButton = $("<input type='button' class='btn btn-primary button submit-btn'></input>");
            jqDummyButton.val($(this).val());
            $(this).after(jqDummyButton);
            $(this).hide();

            jqDummyButton.on("click", function () {

				let jqPrevButton = $(this).prev("input");
                if (jqPrevButton.length == 0) {

                    return;
                }
				
				if (linda.user.linda_jobclasscd == linda.enums.jobClassCd.INTERNAL_USER) {
				    
					// 社内確認用権限の場合、機能制限モーダルを表示
				    $("#modal-feature-limitation").modal("show");
				    return;
				}

                // ログの出力
                let params = linda.logger.getEntityFormParameter();
                let processKbn = jqPrevButton[0].value;
                let pageTitle = document.title;
                linda.logger.sendLogMessage(processKbn, pageTitle, params);

                // 送信ボタンをクリック
                jqPrevButton.click();
            });
        });
    }

    /**
     * エンティティフォームのサブグリッドモーダルの送信にイベントを設定
     */
    linda.logger.setEntityFormSubgridModalSubmitEvent = function () {

        let jqSubmit = $(".submit-btn:visible");
        if (jqSubmit.length == 0) {

            return;
        }

        jqSubmit.each(function () {

			let jqDummyButton = $("<input type='button' class='btn btn-primary button submit-btn'></input>");
			jqDummyButton.val($(this).val());

            // 既存ボタンを非表示にしてダミーボタンを表示
            $(this).after(jqDummyButton);
            $(this).hide();

            jqDummyButton.on("click", function () {

                let jqPrevButton = $(this).prev("input");
                if (jqPrevButton.length == 0) {

                    return;
                }

                if (linda.dialog.params.jobClassCd == linda.enums.jobClassCd.INTERNAL_USER) {

                    // 社内確認用権限の場合、機能制限モーダルを表示
                    $("#modal-feature-limitation", parent.document).modal("show");
                    return;
                }

                // TODO: ログの出力部分は未対応

                // 非表示の送信ボタンをクリック
                jqPrevButton.click();
            });
        });
    }

	/**
     * エンティティフォームのパラメータを取得
     */
    linda.logger.getEntityFormParameter = function () {

        let params = [];

        let jqCells = $("td.clearfix.cell");

		jqCells.each(function() {
            let control = $(this).find(".control > .text, .textarea, .integer, .double, .decimal, .money, .datetime, .boolean-radio, .picklist-cell, .lookup-cell, .lookup");
            if(control.length > 0) {
    
                params.push(linda.logger.getFormattedParameter(control[0].id));
            }
        });

        return params.join(",");
    }

    /**
     * フォーマット済みのパラメータを取得
     * @param {any} in_fieldName
     */
    linda.logger.getFormattedParameter = function (in_fieldName) {

        let fieldInfo = linda.form.getFieldInfo(in_fieldName);
		let fieldValue = linda.form.getFieldValue(in_fieldName);

        return "[" + fieldInfo.jqInfo[0].innerText + "]=" + fieldValue;
    }

    /**
     * エンティティフォームとエンティティリストの共通ボタンにログイベントを設定
     */
    linda.logger.setCommonButtonLogEvent = function () {

        // パラメータ不要なログイベント
        linda.logger.setNoParametersRequiredButtonLogEvent();

        // パラメータが必要なログイベント
        linda.logger.setParameterRequiredButtonLogEvent();
    }

    /**
     * 共通ボタンのパラメータ不要なものについてログイベントを設定
     */
    linda.logger.setNoParametersRequiredButtonLogEvent = function () {

        let jqTargetButton = $(".btn.entitylist-download, .btn.create-action");
        if (jqTargetButton.length == 0) {

            return;
        }

        jqTargetButton.each(function () {

            $(this).on("click", function () {

                // ログの出力
                let processKbn = $(this).text();
                let pageTitle = document.title;
                linda.logger.sendLogMessage(processKbn, pageTitle, "");
            });
        });
    }

    /**
     * 共通ボタンのパラメータが必要なものについてログイベントを設定
     */
    linda.logger.setParameterRequiredButtonLogEvent = function () {

        let jqTargetButton = $(".btn.btn-entitylist-filter-submit");
        if (jqTargetButton.length == 0) {

            return;
        }

        jqTargetButton.each(function () {

            $(this).on("click", function () {

                // ログの出力
                let processKbn = $(this).text().trim();
                let pageTitle = document.title;
                let params = "";
                let jqEntitylist = $(".entitylist");
                if (jqEntitylist.length == 0) {

                    params = linda.logger.getEntityFormParameter();
                }
                else {

                    params = linda.logger.getEntityListFiltersParameter();
                }
                linda.logger.sendLogMessage(processKbn, pageTitle, params);
            });
        });
    }

	//--------------------------------------------------------------------------
	// Event
	//--------------------------------------------------------------------------

    /**
     * ログ出力用のボタンクリックイベント
     */
    linda.logger.btnClick = function (obj) {

        // ログの出力
        let processKbn = obj.title;
        let pageTitle = document.title;
        linda.logger.sendLogMessage(processKbn, pageTitle, "");
    }
})(window.linda);

(function (linda) {

	//環境ごとに変更する必要のあるURL
	const urlEnv = {
		PARTNER_FRONT: "https://cas-portal-dev.it-ex.com/"
	};

	$(document).ready(function () {
		console.debug("◆linda.js document ready.");

		// SSO対応のための分岐
		let jqShibbolethBtn = $("form button[id*='shibboleth']");
		let currentUrl = decodeURIComponent(document.URL).toLowerCase();
		jqShibbolethBtn.hide();
		if (jqShibbolethBtn.size() && (currentUrl.indexOf("/signin") >= 0)) {
			jqShibbolethBtn.click();
		    return;
		}

		// 画面全体を覆うマスクを作成、表示
		linda.form.createMask();
		linda.form.showMask();
		
		let promise = setHeaderColor();
		
		promise.then(function(){
			startFormInitialization();	
		});

		setTabNavigation();
		setTabToggle();
		initEntityListFilterField();
		setModalFormEvent();
		setInitCookieEvent();
		replaceJqueryTimeagoFunction();
		setNavigationBarDisplay();
		
		//ポリシー同意チェックを行う
		//var localData = load_Storage("policyAgrVerChk");
		var ymd = getNowYMD();
		var chkResult = true;
		//モーダルの子画面以外でポリシー同意チェックAPIの呼び出しを行う
		//※モーダルの判定としてdiv.navbar-brandが画面に存在するか否かで判定しています
		if($("div.navbar-brand").length != 0) {
			chkResult = policyAgrVerChk();
		}
		if(!chkResult){
			console.debug("PolicyAgreementVersionCheck...move-partner-front!");
			location.href =urlEnv.PARTNER_FRONT;
		} else{
			console.debug("PolicyAgreementVersionChecked");
			//保存
			//save_Storage("policyAgrVerChk",ymd);
			// 起動ログの出力
			let qstrs = linda.util.getQueryString();
            let qstrsid = qstrs.id;
			let pageTitle = document.title;
			linda.logger.sendLogMessage("初期表示", pageTitle, qstrsid);
		}
		
	});

	function startFormInitialization() {

		const jqBody = $("body");

		// 非同期でデータを取得している箇所（グリッド、メモ）の処理終了をチェック
		// →終了後、form_initializedイベント発生
		{
			let timer = setInterval(function () {
				let jqLoadings = $("div.view-loading, div.notes-loading").filter(":visible");
				console.debug("jqLoadings.length=[" + jqLoadings.length + "]");
				if (jqLoadings.length == 0) {
					clearInterval(timer);
					jqBody.trigger("form_initialized.");
				}
			}, 250);
		}
	}

	//ローカルストレージ読込
	function load_Storage(dataName) {
		var mydata = "";
		if(!localStorage.getItem(dataName)) {
			mydata = "";
		} else {
			mydata = localStorage.getItem(dataName);
		}
		return mydata;
	}
	// ローカルストレージ保存
	function save_Storage(dataName,dataValue) {
		localStorage.setItem(dataName, dataValue);
	}
	function getNowYMD(){
		var dt = new Date();
		var y = dt.getFullYear();
		var m = ("00" + (dt.getMonth()+1)).slice(-2);
		var d = ("00" + dt.getDate()).slice(-2);
		var result = y + m + d;
		return result;
	}

	function setHeaderColor() {
		let deferred = $.Deferred();

		let username = window["Microsoft"].Dynamic365.Portal.User.userName;
		if (!linda.util.isNullOrEmpty(username)) {
			
			linda.ajax.getSystemConfig("PORTAL_COLOR")
				.then(function (in_configs) {
					if (in_configs.length > 0) {
						let config = in_configs[0];
						let color = "#" + config.linda_value;
						$("div.navbar").css("background-color", color);
					}
				})
				.then(function () {
					deferred.resolve();
				}
				, function () {
					deferred.reject();
				});

		} else {
			deferred.resolve();
		}

		return deferred.promise();
	}

	function setTabNavigation() {
		let jqTabs = $("h2.tab-title");

		if (jqTabs.length == 0) {
			return;
		}

		let jqNavi = $("<div class='tab_navigation'>");
		let jqSpacer = $("<span class='spacer'>|</span>");

		for (let idx = 0; idx < jqTabs.length; idx++) {
			let jqTab = jqTabs.eq(idx);
			let jqPanel = jqTab.next("div.tab");
			let tabName = jqPanel.attr("data-name");

			let jqLink = $("<a>");
			jqLink.attr("id", "link_" + tabName);
			jqLink.attr("href", "#" + tabName);
			jqLink.text(jqTab.text());

			if (idx > 0) {
				jqNavi.append(jqSpacer.clone());
			}
			jqNavi.append(jqLink);
		}

		$("div.page-header").append(jqNavi);

		$("body").on("click", "div.tab_navigation a", function (in_event) {
			in_event.preventDefault();

			let jqLink = $(this);
			let tabName = jqLink.attr("href").substr(1);
			let jqPanel = $("div.tab[data-name='" + tabName + "']");
			let jqTab = jqPanel.prev("h2.tab-title");

			linda.form.animationScroll(jqTab);
		});

		$("body").on("changed_tab_visible", function (in_event, in_tabName) {
			let isVisible = linda.form.getTabVisible(in_tabName);
			let jqLink = $("#link_" + in_tabName);
			jqLink.toggle(isVisible);

			$("div.tab_navigation a:visible").prev("span").show();
			$("div.tab_navigation a:hidden").prev("span").hide();

			let jqLinkFirst = $("div.tab_navigation a:first");
			if (jqLinkFirst.is(":hidden")) {
				$("div.tab_navigation a:visible:first").prev("span").hide();
			}
		});
	}

	function setTabToggle() {
		$("h2.tab-title").each(function () {
			let jqTab = $(this);

			jqTab.prepend("<span class='tabstatus'/>");
			jqTab.attr("title", "クリックでこのタブを開閉します。");
		});

		$("body").on("click", "h2.tab-title", function () {
			let jqTab = $(this);
			let jqPanel = jqTab.next("div.tab");

			let isTabOpened = linda.form.isTabOpened(jqTab);
			let tabName = jqPanel.attr("data-name");

			if (isTabOpened) {
				linda.form.closeTab(tabName);
			} else {
				linda.form.openTab(tabName);
			}
		});
	}

	function initEntityListFilterField() {
		let jqFilters = $("ul#entitylist-filters");
		let jqSubmit = $("button.btn.btn-entitylist-filter-submit");

		if (jqFilters.length == 0 || jqSubmit.length == 0) {
			return;
		}

		_setEntityListFilterFieldClearButton();

		// フィルタアイコン非表示
		jqFilters.find("span.fa.fa-filter").closest("span.input-group-addon").hide();

		// スクリプト読み込み
		linda.ajax.loadScripts(null, ["/xrm-adx/js/crmentityformview-datetime.js"]);
	}

	function setSearchBoxSupplementText() {
		//if ($(".list-search-supplement").length == 0) {
		//	$('.page-copy').after('<span class="list-search-supplement">　※検索条件は前回入力時の値を保持しています。新しい条件で検索する場合は「リセット」ボタンを押してから条件を入力してください。</span>');
		//}
	}

	function _setEntityListFilterFieldClearButton() {
		let jqSubmit = $("button.btn.btn-entitylist-filter-submit");

		let jqClear = $("<button/>").addClass("btn btn-default").css("margin-right", "10px").attr("id", "btn_reset");
		let jqSpan = $("<span/>").addClass("fa fa-times");
		jqClear.append(jqSpan);
		jqClear.append($("<span/>").text(" リセット"));

		jqSubmit.before(jqClear);

	}

	function setModalFormEvent() {
		// iframeロード時
		$(".modal-form iframe").on("load", function () {
			console.debug("★.modal-form iframe load.");

			let ifm = this;
			let jqIfm = $(ifm);
			let jqModalForm = jqIfm.closest(".modal-form");

			if (!jqIfm.is(":visible")) {
				return;
			}

			let params = {
				iframe: ifm
				, window: ifm.contentWindow
			};

			jqModalForm.trigger("opendialog", params);

			// lindaが生成されるまで待つ
			let cnt = 0;
			let id = setInterval(function () {
				cnt++;

				let isEnd = false;
				let initForm = null;

				if (!linda.util.isUndef(params.window.linda, ".dialog.initForm")) {
					params.window.linda.dialog.jqIfm = jqIfm;

					jqModalForm.trigger("opendialog_linda", params);

					isEnd = true;
					initForm = params.window.linda.dialog.initForm;
				} else if (cnt >= 30) {
					console.debug("linda.dialog.initForm not found.");

					isEnd = true;
				}

				if (isEnd) {
					clearInterval(id);

					if ($.isFunction(initForm)) {
						// 初期化処理
						setTimeout(function () {
							initForm();
						}, 1);
					}
				}
			}, 100);
		});

		// ダイアログ閉じるとき
		$(".modal-form").on("hidden.bs.modal", function () {
			console.debug("★.modal-form hidden.bs.modal.");

			let jqModalForm = $(this);
			let ifm = jqModalForm.find("iframe").get(0);
			let jqIfm = $(ifm);

			let params = {
				iframe: ifm
				, window: ifm.contentWindow
			};

			jqModalForm.trigger("closedialog", params);
		});
	}


	function replaceJqueryTimeagoFunction() {
		// default-1041.bundle.js の n.fn.timeago を置き換える
		// ※IE、Edgeで落ちるバグ修正、メモ欄の表記を独自化

		function func1() {
			let $this = $(this);
			let t = func2(this);
			if (!isNaN(t.datetime)) {
				let dt = t.orgText;
				let df = func3(t.datetime);
				let dw = $.timeago.inWords(df);
				if ($this.closest(".entity-notes").length > 0) {
					$this.html(dt + "<br/>(" + dw + ")");
				} else {
					$this.text(dw);
				}
			}
			return this;
		}

		function func2(i) {
			if (i = $(i), !i.data("timeago")) {
				let d = {
					datetime: $.timeago.datetime(i)
					, orgText: $.trim(i.text())
				};
				let r = d.orgText;
				if (r.length > 0 && !($.timeago.isTime(i) && i.attr("title"))) {
					i.attr("title", r);
				}
				i.data("timeago", d);
			}
			return i.data("timeago");
		}

		function func3(t) {
			let i = $("html").data("lang");
			let r = Date.parse((new Date).toLocaleString(i).replace(/[^A-Za-z 0-9 \.,\?""!@#\$%\^&\*\(\)-_=\+;:<>\/\\\|\}\{\[\]`~]*/g, ""));
			if (!r) {
				r = (new Date);
			}
			return r.getTime() - t.getTime();
		}

		$.fn.timeago = function () {
			let n = this;
			let s = $.timeago.settings;

			n.each(func1);

			if (s.refreshMillis > 0) {
				setInterval(function () {
					n.each(func1);
				}, s.refreshMillis);
			}

			return n;
		};
	}

	/**
	 * Cookieを初期化するイベントを設定する
	 */
	function setInitCookieEvent() {
		
		// ナビゲーションバーから画面遷移時にCookie初期化
		$("div#navbar .dropdown-menu li:not(.divider)").each(function(index) {
			
			let jqA = $(this).find("a");
			let url = jqA.attr("href");
			if (url == "/casequoteview/") {
				// 見積 > 依頼状況
				$(this).on("click", function() {
					linda.form.initCookieOfQuoteRequest();
				});
			} else if (url == "/quoteview/") {
			    // 見積 > 履歴検索
				$(this).on("click", function() {
					linda.form.initCookieOfQuote();
				});
			} else if (url == "/quotedetailview/") {
				// 見積 > 明細DL
				$(this).on("click", function() {
					linda.form.initCookieOfQuoteDetail();
				});
			} else if (url == "/salesorderview/") {
				// 注文 > 履歴検索
				$(this).on("click", function() {
					linda.form.initCookieOfSalesOrder();
				});
			} else if (url == "/salesorderbulkapproval/") {
				// 注文 > 一括承認
				$(this).on("click", function() {
					linda.form.initCookieOfSalesorderBulkApproval();
				});
			} else if (url == "/caseview/") {
			    // 問い合わせ > 問い合わせ一覧
				$(this).on("click", function() {
					linda.form.initCookieOfContact();
				});
			} else if (url == "/destinationsettingview/") {
				// (ユーザ名) > 納品先設定
				$(this).on("click", function() {
					linda.form.initCookieOfMyDestination();
				});
			} else if (url == "/shippersettingview/") {
				// (ユーザ名) > 荷元設定
				$(this).on("click", function() {
					linda.form.initCookieOfMyShipper();
				});
			} else if (url == "https://cas-exauth-dev.it-ex.com/idp/profile/Logout") {
				// サインアウト
				$(this).on("click", function() {
					linda.form.initCookieOfQuoteRequest();
					linda.form.initCookieOfQuote();
					linda.form.initCookieOfQuoteDetail();
					linda.form.initCookieOfSalesOrder();
					linda.form.initCookieOfSalesorderBulkApproval();
					linda.form.initCookieOfContact();
					linda.form.initCookieOfMyDestination();
					linda.form.initCookieOfMyShipper();
				});
			} else if (url == "/shippingview/") {
			    // 出荷一覧
				$(this).on("click", function() {
					linda.form.initCookieOfShipping();
				});
			}
		});	
	}
	
	/**
	 * 利用規約同意バージョンチェック処理
	 */
	function policyAgrVerChk() {
	
		try {
			//アクセス権限がない場合はnullとなるので処理終了
			if(linda.user.linda_userid == null){
				return true;
			}
			var xhr_gettk = new XMLHttpRequest();
			var tkstatus = false;
			var tkstring;
			//同期処理としてTokenの取得
			xhr_gettk.open('POST',linda.settings.getTokenUrl,false);
			xhr_gettk.setRequestHeader('Cache-Control', 'no-cache');
			xhr_gettk.setRequestHeader('If-Modified-Since', 'Thu, 01 Jun 2010 00:00:00 GMT');

			xhr_gettk.onreadystatechange = function() {
				if(xhr_gettk.readyState == 4) {
					tkstring = xhr_gettk.responseText;
				}
			};
			xhr_gettk.send();

			// Token取得失敗
			if (!tkstring || typeof (tkstring) === 'undefined') {
				return false;
			}
		
			var verChkReq = new XMLHttpRequest();
			verChkReq.onreadystatechange = function()
			{
				if( this.readyState == 4 && this.status == 200 )
				{
					if( this.response )
					{
						 obj = JSON.parse(this.responseText);
						 obj_msg = JSON.parse(obj.result);

					}
				}
			}

			//同期処理で利用規約同意バージョンチェック連携APIの実行
			verChkReq.open( "GET", linda.settings.outSideApiUrl + "VersionChkFunctionLinkApi", false );
			verChkReq.setRequestHeader('Cache-Control', 'no-cache');
			verChkReq.setRequestHeader('If-Modified-Since', 'Thu, 01 Jun 2010 00:00:00 GMT');
		
			verChkReq.setRequestHeader("Authorization" , 'Bearer ' + tkstring);
			verChkReq.setRequestHeader("userid" , linda.user.linda_userid);
			verChkReq.setRequestHeader("companycls" , "01");
			verChkReq.send( null );
			if(obj.success){
				//正常に呼び出せた結果、同意されていなければページ遷移
				if(obj_msg.PlcInfo.PolicyVerChkFlg == "FALSE"){
					return false;
				}
			} else{
				return false;
			}
			return true;
		} catch(e) {
			console.debug("利用規約同意CHKエラー");
			return false;
		}
	}
	
    /**
     * 画面上部のナビゲーションバーの表示設定
     * 
     */
    function setNavigationBarDisplay() {

        let d365usekbn = "";
        linda.ajax.getAccount()
            .then(function (in_result) {
                if (in_result.length > 0) {
                    d365usekbn = in_result[0].linda_d365usevalue;
                }
            })
            .then(function () {
                if (d365usekbn != "11") {

                    // D365利用販社ではない場合
                    let jqNavbar = $(".navbar-nav");
                    if (jqNavbar.length > 0) {

                        let jqRemoveTarget = null;
                        // [見積]新規依頼
                        jqRemoveTarget = jqNavbar.find("a[href='/casequoteview/create-quote/']");
                        if (jqRemoveTarget.length > 0) {

                            jqRemoveTarget.parent().remove();
                        }

                        // [見積]依頼状況
                        jqRemoveTarget = jqNavbar.find("a[href='/casequoteview/']");
                        if (jqRemoveTarget.length > 0) {

                            jqRemoveTarget.parent().remove();
                        }
                    }
                }
            });
    }

})(window.linda);
